#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 27 "awkgram.y"
#ifdef GAWKDEBUG
#define YYDEBUG 12
#endif

#define YYMAXDEPTH 10000 /* default is 500 in byacc-1.9.20070509-6.1.el6 */

#include "awk.h"

#if defined(__STDC__) && __STDC__ < 1	/* VMS weirdness, maybe elsewhere */
#define signed /**/
#endif

#define CAN_FREE	TRUE
#define DONT_FREE	FALSE

#ifdef CAN_USE_STDARG_H
static void yyerror(const char *m, ...) ATTRIBUTE_PRINTF_1;
#else
static void yyerror(); /* va_alist */
#endif
static char *get_src_buf P((void));
static int yylex P((void));
static NODE *node_common P((NODETYPE op));
static NODE *snode P((NODE *subn, NODETYPE op, int sindex));
static NODE *make_for_loop P((NODE *init, NODE *cond, NODE *incr));
static NODE *append_right P((NODE *list, NODE *new));
static inline NODE *append_pattern P((NODE **list, NODE *patt));
static void func_install P((NODE *params, NODE *def));
static void pop_var P((NODE *np, int freeit));
static void pop_params P((NODE *params));
static NODE *make_param P((char *name));
static NODE *mk_rexp P((NODE *exp));
static int dup_parms P((NODE *func));
static void param_sanity P((NODE *arglist));
static int parms_shadow P((const char *fname, NODE *func));
static int isnoeffect P((NODETYPE t));
static int isassignable P((NODE *n));
static void dumpintlstr P((const char *str, size_t len));
static void dumpintlstr2 P((const char *str1, size_t len1, const char *str2, size_t len2));
static void count_args P((NODE *n));
static int isarray P((NODE *n));

enum defref { FUNC_DEFINE, FUNC_USE };
static void func_use P((const char *name, enum defref how));
static void check_funcs P((void));

static ssize_t read_one_line P((int fd, void *buffer, size_t count));
static int one_line_close P((int fd));

static NODE *constant_fold P((NODE *left, NODETYPE op, NODE *right));
static NODE *optimize_concat P((NODE *left, NODETYPE op, NODE *right));

static int want_regexp;		/* lexical scanning kludge */
static int can_return;		/* parsing kludge */
static int begin_or_end_rule = FALSE;	/* parsing kludge */
static int parsing_end_rule = FALSE; /* for warnings */
static int in_print = FALSE;	/* lexical scanning kludge for print */
static int in_parens = 0;	/* lexical scanning kludge for print */
static char *lexptr;		/* pointer to next char during parsing */
static char *lexend;
static char *lexptr_begin;	/* keep track of where we were for error msgs */
static char *lexeme;		/* beginning of lexeme for debugging */
static char *thisline = NULL;
#define YYDEBUG_LEXER_TEXT (lexeme)
static int param_counter;
static char *tokstart = NULL;
static char *tok = NULL;
static char *tokend;

static long func_count;		/* total number of functions */

#define HASHSIZE	1021	/* this constant only used here */
NODE *variables[HASHSIZE];
static int var_count;		/* total number of global variables */

extern char *source;
extern int sourceline;
extern struct src *srcfiles;
extern long numfiles;
extern int errcount;
extern NODE *begin_block;
extern NODE *end_block;

/*
 * This string cannot occur as a real awk identifier.
 * Use it as a special token to make function parsing
 * uniform, but if it's seen, don't install the function.
 * e.g.
 * 	function split(x) { return x }
 * 	function x(a) { return a }
 * should only produce one error message, and not core dump.
 */
static char builtin_func[] = "@builtin";
#line 122 "awkgram.y"
typedef union {
	long lval;
	AWKNUM fval;
	NODE *nodeval;
	NODETYPE nodetypeval;
	char *sval;
	NODE *(*ptrval) P((void));
} YYSTYPE;
#line 126 "y.tab.c"
#define FUNC_CALL 257
#define NAME 258
#define REGEXP 259
#define ERROR 260
#define YNUMBER 261
#define YSTRING 262
#define RELOP 263
#define IO_OUT 264
#define IO_IN 265
#define ASSIGNOP 266
#define ASSIGN 267
#define MATCHOP 268
#define CONCAT_OP 269
#define LEX_BEGIN 270
#define LEX_END 271
#define LEX_IF 272
#define LEX_ELSE 273
#define LEX_RETURN 274
#define LEX_DELETE 275
#define LEX_SWITCH 276
#define LEX_CASE 277
#define LEX_DEFAULT 278
#define LEX_WHILE 279
#define LEX_DO 280
#define LEX_FOR 281
#define LEX_BREAK 282
#define LEX_CONTINUE 283
#define LEX_PRINT 284
#define LEX_PRINTF 285
#define LEX_NEXT 286
#define LEX_EXIT 287
#define LEX_FUNCTION 288
#define LEX_GETLINE 289
#define LEX_NEXTFILE 290
#define LEX_IN 291
#define LEX_AND 292
#define LEX_OR 293
#define INCREMENT 294
#define DECREMENT 295
#define LEX_BUILTIN 296
#define LEX_LENGTH 297
#define NEWLINE 298
#define SLASH_BEFORE_EQUAL 299
#define UNARY 300
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   38,   38,   38,   39,   39,   39,    2,    2,    2,
    2,    2,    3,   34,   34,   34,   36,   36,   44,    1,
   47,   26,   46,   46,   14,   14,   14,   40,   40,   15,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
   15,   15,   15,   50,   15,   15,   51,   22,   22,   22,
   22,   22,   23,   23,   17,   18,   18,   18,   19,   19,
   20,   20,   20,   20,   20,   30,   30,   13,   13,   28,
   53,   28,   16,   16,   48,   48,   37,   37,   27,   27,
   21,   21,    5,    5,    5,    5,    5,   24,   24,   12,
   12,   11,   11,   11,   11,   11,   11,    6,    6,    6,
    6,    6,    6,    6,    6,   31,   31,   31,   33,   33,
   32,   32,    7,    7,    7,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    9,    9,    9,    9,
    9,    9,    9,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   25,   25,    4,
    4,    4,   29,   35,   35,   35,   41,   42,   45,   43,
   43,   49,   52,   54,
};
short yylen[] = {                                         2,
    3,    0,    2,    2,    2,    2,    2,    0,    1,    3,
    1,    1,    5,    1,    1,    1,    1,    1,    0,    7,
    0,    3,    1,    1,    0,    2,    2,    1,    2,    2,
    3,    1,    9,    6,    8,    8,   12,   11,    2,    2,
    2,    2,    3,    0,    4,    2,    0,    4,    5,    2,
    4,    1,    0,    1,    1,    0,    2,    2,    5,    4,
    1,    2,    2,    1,    1,    1,    1,    1,    3,    0,
    0,    3,    6,    9,    1,    2,    0,    1,    0,    2,
    0,    1,    1,    3,    1,    2,    3,    0,    1,    0,
    1,    1,    3,    1,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    5,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    2,    1,    3,    3,    3,    3,
    3,    3,    3,    2,    2,    5,    4,    3,    3,    3,
    3,    3,    3,    1,    2,    3,    4,    4,    1,    4,
    1,    2,    2,    1,    1,    2,    2,    0,    1,    1,
    4,    1,    3,    1,    1,    0,    2,    2,    1,    0,
    1,    1,    1,    2,
};
short yydefred[] = {                                      0,
   75,    0,    2,    0,    0,   76,    4,    0,    0,  144,
  145,   11,   12,   19,    0,    0,    0,    0,    0,   24,
    0,    0,   23,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  116,  134,  152,    1,    3,   21,    0,
    0,    0,  149,    0,  142,  143,    0,    0,    0,    0,
    0,    0,    0,  141,    0,   94,    0,    0,    0,    7,
   25,  162,    5,    6,    0,    0,  107,  106,  124,  125,
    0,    0,  109,    0,    0,    0,    0,    0,    0,  110,
  112,    0,  111,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   15,   14,   17,   18,    0,   16,    0,  123,
    0,    0,    0,  154,  155,  153,  159,  136,    0,    0,
    0,    0,  157,    0,   29,  108,    0,    0,  102,    0,
    0,    0,    0,  103,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   22,  140,  151,
    0,    0,  137,  138,    0,  164,    0,   97,    0,   27,
    0,   44,    0,    0,    0,    0,    0,    0,    0,   66,
   67,    0,    0,    0,    0,    0,   26,   32,    0,   47,
   25,    0,    0,    0,  127,   85,   83,    0,    0,  126,
    0,    0,    0,    0,    0,    0,    0,    0,   39,   40,
   41,    0,    0,   42,  158,   46,    0,    0,    0,  161,
   30,    0,   86,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   54,    0,   43,    0,   68,    0,   31,
   13,   87,   84,   20,    0,   45,    0,   51,    0,    0,
    0,    0,    0,    0,   71,   48,    0,   49,    0,    0,
    0,    0,    0,    0,    0,    0,   56,   34,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   58,    0,    0,   57,   35,   36,    0,    0,
   74,   33,   61,   64,    0,    0,    0,   65,  163,    0,
    0,    0,   63,   62,    0,   25,    0,    0,   25,    0,
    0,   38,    0,   37,
};
short yydgoto[] = {                                       2,
   27,   28,   60,   29,  188,  176,   31,   32,   33,   34,
  100,  101,  229,  124,  177,  178,  265,  266,  276,  287,
  189,  179,  225,  203,   44,   35,  110,  246,   36,  180,
   72,   82,   83,  107,  116,  108,    3,    5,   38,   64,
  181,  182,  209,   42,  118,   39,   98,    4,  183,  192,
  207,  290,  255,  122,
};
short yysindex[] = {                                   -266,
    0,    0,    0, -236, 1176,    0,    0,   19,  -16,    0,
    0,    0,    0,    0,  -23,  -23,  -23,   39,   46,    0,
 3297, 3297,    0, 3297, 1759, 2003,  -27,  -59,  388,  -40,
 2047,   65,  458,    0,    0,    0,    0,    0,    0, 2003,
 2003, -181,    0,   23,    0,    0, 2003, 2003, -256,    7,
    7,    7, 3297,    0, -239,    0,  400,   -1, -266,    0,
    0,    0,    0,    0, -236, -266,    0,    0,    0,    0,
 -167, 3297,    0, 3297, -155, 3297, 3297, 3297, 3297,    0,
    0, 3297,    0, -176,   65, 3297, 3297, 3297, 3297, 3297,
 3297, 3297, 3297, 3297, 3297, 3297, 3297, -142,  672,   43,
   78,  -25,    0,    0,    0,    0,   80,    0, 3297,    0,
   78,   78,  400,    0,    0,    0,    0,    0, 3297, -266,
 -170, 2480,    0, 2366,    0,    0,  672,   49,    0,  292,
  345,  460,  672,    0,  -23,   81,   81,    7,    7,    7,
    7,   81,   81,    7,    7,    7,    7,    0,    0,    0,
 -174,   65,    0,    0,  672,    0, -131,    0,  672,    0,
   90,    0,  -22,   91,   97, -266,   98,  -54,  -54,    0,
    0,  -54, 3297,  -54, -266,  672,    0,    0,  -54,    0,
    0,   82, -266, 3297,    0,    0,    0,   54,   78,    0,
 3297, 3297,   52, -118, 3297, 3297, 2788, 2176,    0,    0,
    0,  672,  -54,    0,    0,    0, 3109, 2366, -266,    0,
    0,  672,    0, -161, -266,  400,  -54, 2003,  104,  400,
  400, -133,  -85,    0,   82,    0, 2003,    0, -117,    0,
    0,    0,    0,    0, -266,    0,   13,    0, -266, -266,
  109, -106, -266,   -1,    0,    0, 2788,    0,  -27, 2788,
 3297,   78, 3234, -170, 3297, -116,    0,    0,  400, -266,
  515, -266, 2047, -266, -266, -206, -266, 2788, -266, 2555,
 2788,   30,    0,  136,  100,    0,    0,    0, 2555,   78,
    0,    0,    0,    0, -101,  -99,  100,    0,    0, -266,
   78, -266,    0,    0, -266,    0, -266, 2788,    0, 2410,
 2788,    0, 2410,    0,
};
short yyrindex[] = {                                    133,
    0,    0,    0,    1,   21,    0,    0,    0,  449,    0,
    0,    0,    0,    0, 1278,    0,    0,    0,  503,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3562,  -57,
 3319, 2876, 2924,    0,    0,    0,    0,    0,    0,  122,
    0,    0,    0,  558,    0,    0,  122,  122, 1322,  602,
  845,  889,    0,    0, 1366,    0,   55,    0, 1646,    0,
    0,    0,    0,    0,   45,   89,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3166,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,  -34,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  424, 3254,
    0,    0,    0,    0,    0,    0,  -30, 3572,    0,  -32,
  548,    0,  -56,    0, 2070, 2125, 2312,  933,  977, 1035,
 1220, 2459, 2503, 1695, 1938, 1982, 2026,    0,    0,    0,
  123, 2745,    0,    0,  475,    0,    0,    0,  529,    0,
    0,    0,    0,    0,    0, 2831,    0,    0,    0,    0,
    0,    0,  -51,    0,   89,   -6,    0,    0,    0,    0,
    0,  182, 1558,    0,    0,    0,    0,  124,    0,    0,
    0,  -51,   -5,    0,    0,    0,    0,  108,    0,    0,
    0,  -49,    0,    0,    0,    0,    6,    0,  133,    0,
    0,  574,    0,    0,   48,    0,    0,    0,    0,    0,
    0,    0, 3209,    0,    0,    0,    0,    0,   10,    0,
    0,    0,    0,    0, 2831,    0,    0,    0,   48, 2831,
    0,    0, 3277,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   94,    0, 1602,    0,    0,    0, 2831,
    0,  162,   11, 2831,   47, -108, 1558,    0,  162,  145,
    0,    0,    0,    0,    0,    0,    0,    0,  145,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1646,
    0, 2831,    0,    0, 1646,    0, 2831,    0,    0,   59,
    0,    0,  189,    0,
};
short yygindex[] = {                                      0,
    0,    0,  146, 3676,    0, 3677,  -78, 1687,    0,  163,
  175,   26,    0, -157,  428,    0,    0,    0,    0,    0,
    0, -165, -221,   -3,   56,  -87,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  289,    0,    0,  -18,
  -12, -178,    0,    0, 1277,    0,    0, 1000, 1498,    0,
    0,  -93,    0,    9,
};
#define YYTABLESIZE 3939
short yytable[] = {                                      62,
   78,    9,   10,   79,   62,   41,   91,   88,   99,   89,
   98,   99,   25,   98,   61,   61,   55,  194,  120,   80,
   77,   81,   78,  208,   91,   99,   99,   98,   98,  230,
   99,    1,  224,   78,   52,   50,   78,   69,   70,  117,
   78,   78,  120,   78,   28,   78,   90,   78,  280,  273,
   70,   72,   52,   50,  114,  115,  120,  291,   40,   78,
   99,    6,   98,   59,   90,    9,   10,  150,   70,   72,
  274,  275,  111,  112,   41,  103,  104,   28,   47,    8,
   28,  186,  109,  187,   28,   48,  120,   28,   77,   28,
   99,   28,   98,  282,  232,   59,  233,  120,   92,  126,
   91,   90,  129,   28,  224,  248,   88,   86,   80,   87,
   81,   89,  135,  224,  105,  106,  148,   90,  117,  151,
  157,   77,   88,   78,   77,   78,  190,   89,   77,  191,
  195,   77,   77,   77,   69,   77,  196,  198,  300,  219,
   62,  303,  218,    8,  238,  241,  245,   77,  251,  199,
  200,  252,   69,  201,  175,  204,  264,  289,   91,  293,
  206,  294,   90,   81,   82,   77,   53,   28,   77,   28,
   77,   77,   77,   63,   91,   77,  263,   77,  285,   77,
  286,  160,   23,   60,  226,   53,  288,   55,  217,   55,
  185,   77,   92,  295,   77,   92,  214,   77,  236,    0,
   58,   77,   77,    0,   77,  242,   77,    0,   77,    0,
   92,   77,    0,   77,  160,  102,    0,  160,    0,    0,
    0,  160,   73,   99,  160,   98,  160,   74,  160,   91,
  119,   99,  228,   98,    9,  193,  257,    0,    1,    0,
    9,   10,    0,    1,   92,    0,   88,    0,   89,    0,
   75,   76,   77,    0,  119,   77,   78,   78,   78,   99,
   99,   78,   78,   91,    0,   99,    0,   98,  119,   90,
   78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   52,   50,   37,   78,   78,   78,   78,  119,   78,
   28,   28,   28,   90,  160,   28,   28,   70,   72,  213,
   92,   73,    0,   59,   28,   28,   28,   28,   28,   28,
   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
   28,   28,   28,   28,   28,   60,   60,    0,   28,   28,
   28,   28,    0,   28,   77,   77,   77,  123,    0,   77,
   77,   80,    0,   81,  125,    0,   60,   69,   77,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   77,    0,
    0,    0,   77,   77,   77,   77,    0,   77,   77,   77,
   77,   69,  237,   77,   77,    0,  283,  284,    0,    0,
    0,  244,   77,   77,   80,    0,   81,   92,  156,    0,
    0,    0,    0,    0,    0,   92,    0,    0,   77,   77,
   77,   77,   77,   77,    0,    0,   77,   77,   77,   77,
    0,   77,    0,    0,   20,    0,   77,  160,  160,  160,
  117,    0,  160,  160,    0,   77,   77,    0,    0,   92,
   77,  160,  160,    0,  197,   77,   77,   77,   77,   80,
   77,   81,   78,  205,   95,   59,   59,   95,    0,  160,
  160,  211,    0,    0,    0,  160,  160,  160,  160,  160,
  160,  150,   95,    0,  150,  150,   59,    0,  150,  150,
  150,  150,  150,  150,   96,  150,    0,  231,    0,   94,
   92,    0,   93,  234,   95,    0,  150,  150,  150,    0,
  150,  150,    0,    0,    0,   96,   95,  184,   96,   80,
    0,   81,   78,  247,    0,    0,    0,  249,  250,    0,
    0,  253,    0,   96,    0,  139,    0,    0,  139,  139,
    0,  150,  150,  139,  139,  139,  139,  139,  268,  139,
  270,   97,  271,  272,   73,  277,    0,  279,    0,   74,
  139,  139,  139,    0,  139,  139,    0,   96,    0,   93,
    0,  150,   93,   62,   80,    0,   81,   78,  296,    0,
  298,    0,   75,  299,    0,  301,    0,   93,  100,    0,
   79,  100,    0,   79,   79,  139,  139,   79,   79,   79,
   79,   79,   79,    0,   79,  100,  100,   73,    0,    0,
  100,    0,   74,    0,  104,   79,   79,  104,    0,   79,
   79,   93,    0,    0,  222,  139,    0,    0,    0,    0,
    0,  104,  104,    0,  147,   75,   76,  147,  147,    0,
  100,  147,  147,  147,  147,  147,  147,    0,  147,    0,
   79,   79,    0,   67,   68,    0,    0,    0,    0,  147,
  147,  147,   73,  147,  147,    0,  104,   74,    0,    0,
  100,    0,    0,    0,  256,    0,    0,  258,    0,   95,
   79,   69,   70,    0,    0,    0,   71,   95,    0,    0,
   75,   76,   77,    0,  147,  278,  104,    0,  281,    0,
    0,    0,    0,    0,  150,  150,  150,    0,    0,  150,
  150,  150,  150,  150,  150,  150,  150,    0,    0,    0,
    0,   95,   73,    0,  147,  302,    0,   74,  304,    0,
   96,   80,    0,   81,   78,    0,    0,  150,   96,  150,
  150,  150,  150,  150,  150,  150,  150,  150,    0,    0,
   75,   76,   77,    0,    0,    0,    0,    0,  139,  139,
  139,    0,    0,  139,  139,  139,  139,  139,  139,  139,
  139,    0,   96,    0,    0,    0,    0,   73,    0,    0,
    0,    0,   74,    0,   93,    0,    0,    0,    0,    0,
    0,  139,   93,  139,  139,  139,  139,  139,  139,  139,
  139,  139,    0,  100,    0,   75,   76,   77,    0,    0,
    0,  100,    0,   79,   79,   79,    0,    0,   79,   79,
   79,   79,   79,   79,   79,   79,   93,    0,    0,  104,
    0,    0,    0,    0,    0,    0,    0,  104,    0,    0,
  100,    0,    0,    0,    0,  100,   79,    0,   79,   79,
   79,   79,   79,   79,   79,   79,   79,  147,  147,  147,
    0,    0,  147,  147,  147,  147,  147,  147,  147,  147,
    0,  104,    0,    0,    0,    0,    0,  146,    0,    0,
  146,  146,    0,    0,  146,  146,  146,  146,  146,  146,
  147,  146,  147,  147,  147,  147,  147,  147,  147,  147,
  147,    0,  146,  146,  146,    0,  146,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  135,    0,    0,  135,  135,    0,    0,  135,  135,
  135,  135,  135,  135,   73,  135,    0,  146,    0,   74,
    0,    0,    0,    0,    0,    0,  135,  135,  135,    0,
  135,  135,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   75,   76,   77,  118,    0,  146,  118,  118,
    0,    0,  118,  118,  118,  118,  118,  118,    0,  118,
    0,  135,    0,    0,    0,    0,    0,    0,    0,    0,
  118,  118,  118,    0,  118,  118,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
    0,  135,  119,  119,    0,    0,  119,  119,  119,  119,
  119,  119,    0,  119,    0,  118,    0,   65,    0,    0,
    0,    0,    0,    0,  119,  119,  119,    0,  119,  119,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  118,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  120,    0,  119,
  120,  120,    0,    0,  120,  120,  120,  120,  120,  120,
    0,  120,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  120,  120,  120,    0,  120,  120,    0,  119,
  146,  146,  146,    0,    0,  146,  146,  146,  146,  146,
  146,  146,  146,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  120,    0,    0,
    0,    0,    0,  146,    0,  146,  146,  146,  146,  146,
  146,  146,  146,  146,  135,  135,  135,    0,    0,  135,
  135,  135,  135,  135,  135,  135,  135,  120,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   65,   65,    0,
    0,   65,    0,   65,    0,    0,    0,  135,   65,  135,
  135,  135,  135,  135,  135,  135,  135,  135,  118,  118,
  118,    0,    0,  118,  118,  118,  118,  118,  118,  118,
  118,    0,   65,    0,    0,    0,    0,    0,   24,    0,
    0,   25,    0,    0,    0,   26,   65,    0,   21,    0,
   22,  118,   23,  118,  118,  118,  118,  118,  118,  118,
  118,  118,  119,  119,  119,    0,    0,  119,  119,  119,
  119,  119,  119,  119,  119,    0,    0,    0,    0,    0,
    0,    0,  117,    0,    0,  117,  117,    0,    0,  117,
  117,  117,  117,  117,  117,  119,  117,  119,  119,  119,
  119,  119,  119,  119,  119,  119,    0,  117,  117,  117,
    0,  117,  117,    0,    0,    0,    0,    0,    0,    0,
  120,  120,  120,    0,    0,  120,  120,  120,  120,  120,
  120,  120,  120,    0,    0,    0,    0,    0,    0,    0,
  148,    0,  117,    0,  148,    0,    0,  148,  148,  148,
  148,  148,  148,  120,  148,  120,  120,  120,  120,  120,
  120,  120,  120,  120,  121,  148,  148,  148,    0,  148,
  148,    0,  117,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,    0,    0,  141,  141,    0,
    0,  141,  141,  141,  141,  141,  141,    0,  141,    0,
  148,  148,    0,    0,    0,    0,    0,  149,    0,  141,
  141,  141,    0,  141,  141,    0,    0,  153,  154,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  156,    0,
  148,  156,  156,    0,    0,  156,  156,  156,  156,  156,
  156,    0,  156,    0,  141,  141,    0,    0,    0,    0,
    0,    0,    0,  156,  156,  156,    0,  156,  156,    0,
    0,    7,    8,    9,    0,    0,   10,   11,    0,    0,
    0,    0,    0,    0,  141,   12,   13,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  156,  156,
    0,    0,    0,   14,   15,  215,    0,    0,    0,   16,
   17,   18,   19,    1,   20,  117,  117,  117,    0,    0,
  117,  117,  117,  117,  117,  117,  117,  117,  156,    0,
    0,    0,  235,    0,    0,    0,  239,  240,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  117,    0,
  117,  117,  117,  117,  117,  117,  117,  117,  117,    0,
  254,    0,    0,    0,    0,   66,    0,    0,  260,    0,
    0,    0,    0,  148,  148,  267,    0,    0,  148,  148,
  148,  148,  148,  148,  148,  148,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  292,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  148,  297,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  141,  141,  141,
    0,    0,  141,  141,  141,  141,  141,  141,  141,  141,
   77,    0,    0,   77,    0,    0,    0,   77,    0,    0,
   77,    0,   77,    0,   77,    0,    0,    0,    0,    0,
  141,    0,  141,  141,  141,    0,   77,  141,  141,  141,
  141,  156,  156,  156,    0,    0,  156,  156,  156,  156,
  156,  156,  156,  156,   73,    0,    0,   73,    0,    0,
    0,   73,    0,    0,   73,    0,   73,    0,   73,    0,
    0,    0,    0,    0,  156,    0,  156,  156,  156,    0,
   73,  156,  156,  156,  156,   66,   66,    0,    0,   66,
    0,   66,    0,    0,    0,    0,   66,    0,   77,  210,
   77,   77,   77,    0,    0,   77,    0,    0,   77,    0,
   77,    0,   77,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,    0,   77,    0,    0,   50,   51,    0,
   52,    0,    0,    0,   66,    0,    0,   85,    0,    0,
    0,    0,  243,    0,   73,    0,   73,  129,    0,    0,
  129,  129,    0,    0,  129,  129,  129,  129,  129,  129,
    0,  129,    0,    0,    0,    0,    0,    0,    0,    0,
  262,    0,  129,  129,  129,    0,  129,  129,  269,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   77,    0,
   77,    0,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,    0,    0,    0,  129,    0,    0,
    0,   24,    0,    0,   25,  152,    0,    0,   53,    0,
    0,   21,    0,   22,    0,   23,    0,    0,    0,    0,
    0,    0,    0,   77,   77,   77,    0,  129,   77,   77,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
   77,   77,   77,   77,   77,    0,   77,   77,    0,    0,
    0,   77,   77,   77,   77,    0,   77,   73,   73,   73,
    0,    0,   73,   73,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   73,    0,   73,   73,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,    0,
   73,   73,    0,    0,    0,   73,   73,   73,   73,   73,
   73,   77,   77,   77,    0,    0,   77,   77,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   77,    0,   77,
   77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
   77,   77,   77,    0,   77,   77,    0,    0,    0,   77,
   77,   77,   77,    0,   77,    0,    0,    0,    0,   85,
  129,  129,  129,    0,    0,  129,  129,  129,  129,  129,
    0,    0,  129,    0,    0,    0,    0,    0,    0,    0,
  130,    0,    0,  130,  130,    0,    0,  130,  130,  130,
  130,  130,  130,  129,  130,  129,  129,  129,  129,  129,
  129,  129,  129,  129,    0,  130,  130,  130,    0,  130,
  130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  131,    8,    9,  131,  131,   10,
   11,  131,  131,  131,  131,  131,  131,    0,  131,    0,
  130,    0,    0,    0,    0,   24,    0,    0,   25,  131,
  131,  131,   26,  131,  131,   21,    0,   22,    0,   23,
    0,    0,   16,   17,   18,   19,    0,   20,  128,    0,
  130,  128,  128,    0,    0,  128,  128,  128,  128,  128,
  128,    0,  128,    0,  131,    0,    0,    0,    0,   24,
    0,    0,   25,  128,  128,  128,   26,  128,  128,   21,
    0,   22,    0,   23,    0,    0,    0,    0,    0,    0,
    0,    0,  148,    0,  131,    0,  148,    0,    0,  148,
  148,  148,  148,  148,  148,    0,  148,    0,  128,    0,
    0,    0,    0,    0,    0,    0,    0,  148,  148,  148,
    0,  148,  148,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,    0,
    0,    0,    0,    0,    0,    0,    0,  121,    0,    0,
  121,    0,  148,  148,  121,  121,    0,  121,  121,  121,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  121,  121,  121,    0,  121,  121,    0,    0,
    0,    0,  148,  130,  130,  130,    0,    0,  130,  130,
  130,  130,  130,    0,    0,  130,    0,    0,   24,    0,
    0,   25,    0,    0,    0,   26,    0,  121,   21,    0,
   22,    0,   23,    0,    0,    0,  130,    0,  130,  130,
  130,  130,  130,  130,  130,  130,  130,  131,  131,  131,
    0,    0,  131,  131,  131,  131,  131,  121,    0,  131,
    0,    0,    0,    0,    0,    0,    0,    0,   56,    8,
    9,    0,    0,   10,   11,    0,    0,    0,    0,    0,
  131,    0,  131,  131,  131,  131,  131,  131,  131,  131,
  131,  128,  128,  128,    0,    0,  128,  128,  128,  128,
  128,   15,    0,  128,    0,    0,   16,   17,   18,   19,
    0,   20,    0,    8,    9,    0,    0,   10,   11,    0,
    0,   84,    0,    0,  128,    0,  128,  128,  128,  128,
  128,  128,  128,  128,  128,  148,  148,    0,    0,    0,
  148,  148,  148,  148,  148,   15,    0,  148,    0,    0,
   16,   17,   18,   19,  122,   20,    0,  122,    0,    0,
    0,  122,  122,    0,  122,  122,  122,    0,  148,    0,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  122,
  122,  122,    0,  122,  122,    0,    0,    0,    0,    0,
  121,  121,  121,    0,    0,  121,  121,  121,  121,  121,
  121,  121,  121,    0,    0,    0,    0,    0,   24,    0,
    0,   25,    0,    0,  122,   26,    0,    0,   21,    0,
   22,    0,   23,  121,    0,  121,  121,  121,  121,  121,
  121,  121,  121,  121,   62,    0,    0,    0,    0,    0,
    0,    0,    8,  223,  122,    0,   10,   11,    0,    0,
    0,    0,   24,    0,    0,   25,    0,    0,    0,   26,
  163,    0,   21,    0,   22,    0,   23,    0,    0,  170,
  171,    0,    0,    0,   15,    0,    0,    0,   62,   16,
   17,   18,   19,    0,   20,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   59,    0,
  175,  132,    0,    0,  132,    0,    0,    0,  132,  132,
    0,  132,  132,  132,    0,    0,    0,    0,    0,    0,
    0,    0,   24,    0,    0,   25,  132,  132,  132,   26,
  132,  132,   21,    0,   22,    0,   23,    0,    0,    0,
    0,    0,   59,    0,    0,  133,    0,    0,  133,    0,
    0,    0,  133,  133,    0,  133,  133,  133,    0,    0,
    0,  132,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  133,  133,    0,  133,  133,    0,  122,  122,  122,
    0,    0,  122,  122,  122,  122,  122,  122,  122,  122,
    0,  132,    0,    0,    0,    0,    0,   24,    0,    0,
   25,    0,    0,    0,   26,  133,    0,   21,    0,   22,
  122,   23,  122,  122,  122,  122,  122,  122,  122,  122,
  122,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  160,    8,    9,    0,  133,   10,   11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,    0,  162,
  163,  164,    0,    0,  165,  166,  167,  168,  169,  170,
  171,  172,  173,    0,   15,  174,    0,    0,    0,   16,
   17,   18,   19,    0,   20,  160,    8,    9,    0,    0,
   10,   11,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  161,    0,  162,  163,  164,    0,    0,  165,  166,
  167,  168,  169,  170,  171,  172,  173,    0,   15,  174,
    0,    0,    0,   16,   17,   18,   19,    0,   20,    0,
    0,    0,    0,    0,  132,  132,  132,    0,    0,  132,
  132,  132,  132,  132,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,    0,  158,    8,    9,    0,    0,
   10,   11,    0,    0,    0,    0,    0,  132,    0,  132,
  132,  132,  132,  132,  132,  132,  132,  132,  133,  133,
  133,    0,    0,  133,  133,  133,  133,  133,   15,    0,
  133,    0,    0,   16,   17,   18,   19,   80,   20,    0,
   80,    0,    0,    0,   80,   80,    0,    0,   80,    0,
    0,  133,    0,  133,  133,  133,  133,  133,  133,  133,
  133,  133,   80,   80,   80,    0,   80,   80,    0,    0,
    0,    8,    9,    0,    0,   10,   11,    0,    0,    0,
   24,    0,    0,   25,    0,    0,    0,   26,    0,  163,
   21,    0,   22,    0,   23,    0,    0,   80,  170,  171,
    0,    0,    0,   15,    0,    0,   62,    0,   16,   17,
   18,   19,    0,   20,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   77,    0,    0,   77,   80,    0,    0,
   77,    0,    0,   77,    0,   77,    0,   77,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   77,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  113,    0,
   59,  113,    0,    0,    0,  113,  113,    0,    0,  113,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  113,  113,  113,    0,  113,  113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   77,    0,    0,  114,    0,    0,  114,
    0,    0,    0,  114,  114,    0,    0,  114,  113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  114,  114,  114,    0,  114,  114,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  113,    0,
   80,   80,   80,    0,    0,   80,   80,   80,   80,   80,
   80,   80,   80,    0,    0,    0,  114,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   80,    0,   80,   80,   80,   80,   80,
   80,   80,   80,   80,    8,    9,  114,    0,   10,   11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
    0,  162,  163,  164,    0,    0,  165,  166,  167,  168,
  169,  170,  171,  172,  173,    0,   15,  174,    0,    0,
    0,   16,   17,   18,   19,    0,   20,   77,   77,    0,
    0,   77,   77,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   77,    0,   77,   77,   77,    0,    0,   77,
   77,   77,   77,   77,   77,   77,   77,   77,    0,   77,
   77,    0,    0,    0,   77,   77,   77,   77,    0,   77,
    0,  113,  113,  113,    0,    0,  113,  113,  113,  113,
  113,   24,    0,  113,   25,    0,    0,    0,  227,    0,
    0,   21,    0,   22,    0,   23,    0,    0,    0,    0,
    0,    0,    0,    0,  113,    0,  113,  113,  113,  113,
  113,  113,  113,  113,  113,    0,    0,    0,    0,  114,
  114,  114,    0,    0,  114,  114,  114,  114,  114,    0,
    0,  114,    0,    0,    0,    0,    0,    0,  115,    0,
    0,  115,    0,    0,    0,  115,  115,    0,    0,  115,
    0,    0,  114,    0,  114,  114,  114,  114,  114,  114,
  114,  114,  114,  115,  115,  115,    0,  115,  115,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  150,    0,    0,  150,  150,    0,    0,  150,    0,
  150,  150,    0,  150,    0,  150,    0,    0,  115,    0,
    0,    0,    0,    0,    0,    0,   24,  150,  150,   25,
  150,  150,    0,   26,    0,    0,   21,    0,   22,    0,
   23,    0,    0,    0,    0,    0,   77,    0,  115,   77,
    0,    0,   62,   77,    0,    0,   77,    0,   77,    0,
   77,    0,  150,    0,    0,    0,    0,    0,    0,   77,
    0,    0,   77,    0,    0,    0,   77,    0,    0,   77,
    0,   77,    0,   77,    0,    0,    0,    0,    0,   24,
    0,    0,   25,    0,    0,   77,   26,    0,    0,   21,
    0,   22,    0,   23,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  105,
    0,    0,  105,    0,   56,    8,    9,    0,    0,   10,
   11,    0,    0,    0,    0,    0,  105,  105,  105,    0,
  105,  105,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   15,    0,    0,
    0,    0,   16,   17,   18,   19,    0,   20,    0,    0,
    0,  105,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  115,  115,  115,    0,    0,  115,  115,  115,  115,
  115,    0,    0,  115,    0,    0,    0,    0,    0,    0,
    0,  105,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  115,    0,  115,  115,  115,  115,
  115,  115,  115,  115,  115,  150,  150,    0,    0,  150,
  150,  150,    0,  150,  150,  150,  150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    8,    9,    0,    0,   10,   11,    0,  150,    0,    0,
  150,  150,  150,  150,  150,  150,    0,  150,    0,   77,
   77,   77,    0,    0,   77,   77,    0,    0,    0,    0,
    0,    0,   15,    0,    0,    0,    0,   16,   17,   18,
   19,    0,   20,   77,   77,    0,    0,   77,   77,    0,
    0,    0,   77,    0,    0,    0,    0,   77,   77,   77,
   77,    0,   77,    8,    9,    0,    0,   10,   11,    0,
    0,    0,    0,    0,    0,   77,    0,    0,    0,    0,
   77,   77,   77,   77,  105,   77,    0,    0,    0,    0,
    0,  105,  105,    0,    0,   15,  105,    0,    0,    0,
   16,   17,   18,   19,  141,   20,    0,  141,  141,    0,
    0,  141,  141,  141,  141,  141,  141,    0,  141,  105,
  105,  105,  101,    0,    0,  101,  105,    0,    0,  141,
  141,  141,    0,  141,  141,    0,    0,    0,    0,  101,
  101,    0,    0,    0,  101,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  141,  141,    0,    0,    0,    0,
    0,    0,    0,    0,  101,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   30,    0,    0,  141,    0,    0,    0,    0,    0,
   43,   45,   46,    0,  101,    0,   49,   49,    0,   49,
   54,    0,   57,    0,    0,    0,   49,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   99,   99,    0,    0,
    0,    0,    0,   99,   99,    0,    0,    0,    0,  113,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  127,    0,
  128,    0,  130,  131,  132,  133,    0,    0,  134,    0,
    0,   49,   49,   49,   49,   49,   49,   49,   49,   49,
   49,   49,   49,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   49,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  155,    0,    0,  159,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   43,    0,    0,    0,    0,    0,    0,  141,  141,  141,
    0,    0,  141,  141,  141,  141,  141,  101,    0,  141,
    0,    0,    0,    0,    0,  101,    0,    0,    0,  101,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  202,
  141,    0,  141,  141,  141,    0,    0,  141,  141,  141,
  212,    0,  101,  101,  101,    0,    0,  216,  202,  101,
    0,  220,  221,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   99,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   99,    0,    0,    0,    0,    0,
    0,    0,    0,   57,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  259,    0,  261,
   49,    0,    0,    0,    0,    0,    0,    0,   49,
};
short yycheck[] = {                                      59,
    0,   59,   59,   44,   59,   91,   41,   59,   41,   59,
   41,   44,   36,   44,   27,   28,  125,   40,   44,   60,
    0,   62,   63,  181,   59,   58,   59,   58,   59,  208,
   63,  298,  198,   33,   41,   41,   36,  294,  295,   41,
   40,   41,   44,   43,    0,   45,   41,   47,  270,  256,
   41,   41,   59,   59,  294,  295,   44,  279,   40,   59,
   93,  298,   93,  123,   59,  123,  123,   93,   59,   59,
  277,  278,   47,   48,   91,  257,  258,   33,   40,   59,
   36,  256,   60,  258,   40,   40,   44,   43,    0,   45,
  123,   47,  123,  272,  256,  123,  258,   44,   44,  267,
   94,   37,  258,   59,  270,   93,   42,   43,   60,   45,
   62,   47,  289,  279,  296,  297,  259,   37,   41,   40,
  291,   33,   42,  123,   36,  125,  258,   47,   40,   40,
   40,   43,    0,   45,   41,   47,   40,   40,  296,  258,
   59,  299,   91,  123,   41,  279,  264,   59,   40,  168,
  169,  258,   59,  172,  125,  174,  273,   58,   94,  261,
  179,  261,   41,   41,   41,   33,   59,  123,   36,  125,
  123,  125,   40,   28,   94,   43,  255,   45,   43,   47,
   45,    0,   47,  125,  203,   41,  274,   25,  192,  298,
  135,   59,   41,  287,   33,   44,  188,   36,  217,   -1,
   26,   40,   41,   -1,   43,  291,   45,   -1,   47,   -1,
   59,  123,   -1,  125,   33,   41,   -1,   36,   -1,   -1,
   -1,   40,  263,  256,   43,  256,   45,  268,   47,  264,
  256,  264,  207,  264,  258,  258,  249,   -1,  298,   -1,
  298,  298,   -1,  298,   93,   -1,  298,   -1,  298,   -1,
  291,  292,  293,   -1,  256,  123,  256,  257,  258,  292,
  293,  261,  262,  298,   -1,  298,   -1,  298,  256,  264,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  298,  298,    5,  294,  295,  296,  297,  256,  299,
  256,  257,  258,  298,  123,  261,  262,  298,  298,  256,
  256,  263,   -1,  125,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  277,  278,   -1,  294,  295,
  296,  297,   -1,  299,  256,  257,  258,   59,   -1,  261,
  262,   60,   -1,   62,   66,   -1,  298,  264,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,   -1,  294,  295,  296,  297,   -1,  299,  256,  257,
  258,  298,  218,  261,  262,   -1,  261,  262,   -1,   -1,
   -1,  227,  270,  271,   60,   -1,   62,  256,  120,   -1,
   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,  257,  258,
  288,  289,  261,  262,   -1,   -1,  294,  295,  296,  297,
   -1,  299,   -1,   -1,  299,   -1,  275,  256,  257,  258,
   41,   -1,  261,  262,   -1,  284,  285,   -1,   -1,  298,
  289,  270,  271,   -1,  166,  294,  295,  296,  297,   60,
  299,   62,   63,  175,   41,  277,  278,   44,   -1,  288,
  289,  183,   -1,   -1,   -1,  294,  295,  296,  297,  298,
  299,   33,   59,   -1,   36,   37,  298,   -1,   40,   41,
   42,   43,   44,   45,   37,   47,   -1,  209,   -1,   42,
   43,   -1,   45,  215,   47,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   41,   93,   58,   44,   60,
   -1,   62,   63,  235,   -1,   -1,   -1,  239,  240,   -1,
   -1,  243,   -1,   59,   -1,   33,   -1,   -1,   36,   37,
   -1,   93,   94,   41,   42,   43,   44,   45,  260,   47,
  262,   94,  264,  265,  263,  267,   -1,  269,   -1,  268,
   58,   59,   60,   -1,   62,   63,   -1,   93,   -1,   41,
   -1,  123,   44,   59,   60,   -1,   62,   63,  290,   -1,
  292,   -1,  291,  295,   -1,  297,   -1,   59,   41,   -1,
   33,   44,   -1,   36,   37,   93,   94,   40,   41,   42,
   43,   44,   45,   -1,   47,   58,   59,  263,   -1,   -1,
   63,   -1,  268,   -1,   41,   58,   59,   44,   -1,   62,
   63,   93,   -1,   -1,  197,  123,   -1,   -1,   -1,   -1,
   -1,   58,   59,   -1,   33,  291,  292,   36,   37,   -1,
   93,   40,   41,   42,   43,   44,   45,   -1,   47,   -1,
   93,   94,   -1,  266,  267,   -1,   -1,   -1,   -1,   58,
   59,   60,  263,   62,   63,   -1,   93,  268,   -1,   -1,
  123,   -1,   -1,   -1,  247,   -1,   -1,  250,   -1,  256,
  123,  294,  295,   -1,   -1,   -1,  299,  264,   -1,   -1,
  291,  292,  293,   -1,   93,  268,  123,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  256,  257,  258,   -1,   -1,  261,
  262,  263,  264,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,  298,  263,   -1,  123,  298,   -1,  268,  301,   -1,
  256,   60,   -1,   62,   63,   -1,   -1,  289,  264,  291,
  292,  293,  294,  295,  296,  297,  298,  299,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,   -1,  256,  257,
  258,   -1,   -1,  261,  262,  263,  264,  265,  266,  267,
  268,   -1,  298,   -1,   -1,   -1,   -1,  263,   -1,   -1,
   -1,   -1,  268,   -1,  256,   -1,   -1,   -1,   -1,   -1,
   -1,  289,  264,  291,  292,  293,  294,  295,  296,  297,
  298,  299,   -1,  256,   -1,  291,  292,  293,   -1,   -1,
   -1,  264,   -1,  256,  257,  258,   -1,   -1,  261,  262,
  263,  264,  265,  266,  267,  268,  298,   -1,   -1,  256,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,
  293,   -1,   -1,   -1,   -1,  298,  289,   -1,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  256,  257,  258,
   -1,   -1,  261,  262,  263,  264,  265,  266,  267,  268,
   -1,  298,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   36,   37,   -1,   -1,   40,   41,   42,   43,   44,   45,
  289,   47,  291,  292,  293,  294,  295,  296,  297,  298,
  299,   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,   36,   37,   -1,   -1,   40,   41,
   42,   43,   44,   45,  263,   47,   -1,   93,   -1,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  291,  292,  293,   33,   -1,  123,   36,   37,
   -1,   -1,   40,   41,   42,   43,   44,   45,   -1,   47,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,
   -1,  123,   36,   37,   -1,   -1,   40,   41,   42,   43,
   44,   45,   -1,   47,   -1,   93,   -1,   28,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   93,
   36,   37,   -1,   -1,   40,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,  123,
  256,  257,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   -1,   -1,   -1,  289,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  256,  257,  258,   -1,   -1,  261,
  262,  263,  264,  265,  266,  267,  268,  123,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  168,  169,   -1,
   -1,  172,   -1,  174,   -1,   -1,   -1,  289,  179,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  256,  257,
  258,   -1,   -1,  261,  262,  263,  264,  265,  266,  267,
  268,   -1,  203,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   36,   -1,   -1,   -1,   40,  217,   -1,   43,   -1,
   45,  289,   47,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  256,  257,  258,   -1,   -1,  261,  262,  263,
  264,  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   36,   37,   -1,   -1,   40,
   41,   42,   43,   44,   45,  289,   47,  291,  292,  293,
  294,  295,  296,  297,  298,  299,   -1,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   93,   -1,   37,   -1,   -1,   40,   41,   42,
   43,   44,   45,  289,   47,  291,  292,  293,  294,  295,
  296,  297,  298,  299,   58,   58,   59,   60,   -1,   62,
   63,   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   36,   37,   -1,
   -1,   40,   41,   42,   43,   44,   45,   -1,   47,   -1,
   93,   94,   -1,   -1,   -1,   -1,   -1,  101,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,  111,  112,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
  123,   36,   37,   -1,   -1,   40,   41,   42,   43,   44,
   45,   -1,   47,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,
   -1,  256,  257,  258,   -1,   -1,  261,  262,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  270,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
   -1,   -1,   -1,  288,  289,  189,   -1,   -1,   -1,  294,
  295,  296,  297,  298,  299,  256,  257,  258,   -1,   -1,
  261,  262,  263,  264,  265,  266,  267,  268,  123,   -1,
   -1,   -1,  216,   -1,   -1,   -1,  220,  221,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  289,   -1,
  291,  292,  293,  294,  295,  296,  297,  298,  299,   -1,
  244,   -1,   -1,   -1,   -1,   28,   -1,   -1,  252,   -1,
   -1,   -1,   -1,  256,  257,  259,   -1,   -1,  261,  262,
  263,  264,  265,  266,  267,  268,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  289,  291,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  256,  257,  258,
   -1,   -1,  261,  262,  263,  264,  265,  266,  267,  268,
   33,   -1,   -1,   36,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
  289,   -1,  291,  292,  293,   -1,   59,  296,  297,  298,
  299,  256,  257,  258,   -1,   -1,  261,  262,  263,  264,
  265,  266,  267,  268,   33,   -1,   -1,   36,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,  289,   -1,  291,  292,  293,   -1,
   59,  296,  297,  298,  299,  168,  169,   -1,   -1,  172,
   -1,  174,   -1,   -1,   -1,   -1,  179,   -1,   33,  182,
  123,   36,  125,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  203,   -1,   -1,   -1,   59,   -1,   -1,   21,   22,   -1,
   24,   -1,   -1,   -1,  217,   -1,   -1,   31,   -1,   -1,
   -1,   -1,  225,   -1,  123,   -1,  125,   33,   -1,   -1,
   36,   37,   -1,   -1,   40,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  253,   -1,   58,   59,   60,   -1,   62,   63,  261,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  125,   -1,   86,   87,   88,   89,   90,   91,   92,   93,
   94,   95,   96,   97,   -1,   -1,   -1,   93,   -1,   -1,
   -1,   33,   -1,   -1,   36,  109,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  257,  258,   -1,  123,  261,  262,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,   -1,  289,  290,   -1,   -1,
   -1,  294,  295,  296,  297,   -1,  299,  256,  257,  258,
   -1,   -1,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  272,   -1,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,   -1,
  289,  290,   -1,   -1,   -1,  294,  295,  296,  297,  298,
  299,  256,  257,  258,   -1,   -1,  261,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,   -1,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,   -1,  289,  290,   -1,   -1,   -1,  294,
  295,  296,  297,   -1,  299,   -1,   -1,   -1,   -1,  263,
  256,  257,  258,   -1,   -1,  261,  262,  263,  264,  265,
   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   36,   37,   -1,   -1,   40,   41,   42,
   43,   44,   45,  289,   47,  291,  292,  293,  294,  295,
  296,  297,  298,  299,   -1,   58,   59,   60,   -1,   62,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,  257,  258,   36,   37,  261,
  262,   40,   41,   42,   43,   44,   45,   -1,   47,   -1,
   93,   -1,   -1,   -1,   -1,   33,   -1,   -1,   36,   58,
   59,   60,   40,   62,   63,   43,   -1,   45,   -1,   47,
   -1,   -1,  294,  295,  296,  297,   -1,  299,   33,   -1,
  123,   36,   37,   -1,   -1,   40,   41,   42,   43,   44,
   45,   -1,   47,   -1,   93,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   36,   58,   59,   60,   40,   62,   63,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,  123,   -1,   37,   -1,   -1,   40,
   41,   42,   43,   44,   45,   -1,   47,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   36,   -1,   93,   94,   40,   41,   -1,   43,   44,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,   -1,  123,  256,  257,  258,   -1,   -1,  261,  262,
  263,  264,  265,   -1,   -1,  268,   -1,   -1,   33,   -1,
   -1,   36,   -1,   -1,   -1,   40,   -1,   93,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,  289,   -1,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  256,  257,  258,
   -1,   -1,  261,  262,  263,  264,  265,  123,   -1,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,
  258,   -1,   -1,  261,  262,   -1,   -1,   -1,   -1,   -1,
  289,   -1,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  256,  257,  258,   -1,   -1,  261,  262,  263,  264,
  265,  289,   -1,  268,   -1,   -1,  294,  295,  296,  297,
   -1,  299,   -1,  257,  258,   -1,   -1,  261,  262,   -1,
   -1,  265,   -1,   -1,  289,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  256,  257,   -1,   -1,   -1,
  261,  262,  263,  264,  265,  289,   -1,  268,   -1,   -1,
  294,  295,  296,  297,   33,  299,   -1,   36,   -1,   -1,
   -1,   40,   41,   -1,   43,   44,   45,   -1,  289,   -1,
  291,  292,  293,  294,  295,  296,  297,  298,  299,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
  256,  257,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   36,   -1,   -1,   93,   40,   -1,   -1,   43,   -1,
   45,   -1,   47,  289,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  299,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  123,   -1,  261,  262,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   36,   -1,   -1,   -1,   40,
  275,   -1,   43,   -1,   45,   -1,   47,   -1,   -1,  284,
  285,   -1,   -1,   -1,  289,   -1,   -1,   -1,   59,  294,
  295,  296,  297,   -1,  299,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  125,   33,   -1,   -1,   36,   -1,   -1,   -1,   40,   41,
   -1,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   36,   58,   59,   60,   40,
   62,   63,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  123,   -1,   -1,   33,   -1,   -1,   36,   -1,
   -1,   -1,   40,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   -1,   62,   63,   -1,  256,  257,  258,
   -1,   -1,  261,  262,  263,  264,  265,  266,  267,  268,
   -1,  123,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   36,   -1,   -1,   -1,   40,   93,   -1,   43,   -1,   45,
  289,   47,  291,  292,  293,  294,  295,  296,  297,  298,
  299,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,  257,  258,   -1,  123,  261,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,   -1,  274,
  275,  276,   -1,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,   -1,  289,  290,   -1,   -1,   -1,  294,
  295,  296,  297,   -1,  299,  256,  257,  258,   -1,   -1,
  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  272,   -1,  274,  275,  276,   -1,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,   -1,  289,  290,
   -1,   -1,   -1,  294,  295,  296,  297,   -1,  299,   -1,
   -1,   -1,   -1,   -1,  256,  257,  258,   -1,   -1,  261,
  262,  263,  264,  265,   -1,   -1,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  258,   -1,   -1,
  261,  262,   -1,   -1,   -1,   -1,   -1,  289,   -1,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  256,  257,
  258,   -1,   -1,  261,  262,  263,  264,  265,  289,   -1,
  268,   -1,   -1,  294,  295,  296,  297,   33,  299,   -1,
   36,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,  289,   -1,  291,  292,  293,  294,  295,  296,  297,
  298,  299,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,  257,  258,   -1,   -1,  261,  262,   -1,   -1,   -1,
   33,   -1,   -1,   36,   -1,   -1,   -1,   40,   -1,  275,
   43,   -1,   45,   -1,   47,   -1,   -1,   93,  284,  285,
   -1,   -1,   -1,  289,   -1,   -1,   59,   -1,  294,  295,
  296,  297,   -1,  299,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   33,   -1,   -1,   36,  123,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
  123,   36,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   -1,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  123,   -1,   -1,   33,   -1,   -1,   36,
   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,
  256,  257,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  289,   -1,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  257,  258,  123,   -1,  261,  262,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  272,
   -1,  274,  275,  276,   -1,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,   -1,  289,  290,   -1,   -1,
   -1,  294,  295,  296,  297,   -1,  299,  257,  258,   -1,
   -1,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  272,   -1,  274,  275,  276,   -1,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,   -1,  289,
  290,   -1,   -1,   -1,  294,  295,  296,  297,   -1,  299,
   -1,  256,  257,  258,   -1,   -1,  261,  262,  263,  264,
  265,   33,   -1,  268,   36,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  289,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,   -1,   -1,   -1,   -1,  256,
  257,  258,   -1,   -1,  261,  262,  263,  264,  265,   -1,
   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   36,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,
   -1,   -1,  289,   -1,  291,  292,  293,  294,  295,  296,
  297,  298,  299,   58,   59,   60,   -1,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,   36,   37,   -1,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   59,   60,   36,
   62,   63,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   33,   -1,  123,   36,
   -1,   -1,   59,   40,   -1,   -1,   43,   -1,   45,   -1,
   47,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   36,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   36,   -1,   -1,   59,   40,   -1,   -1,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,  256,  257,  258,   -1,   -1,  261,
  262,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  289,   -1,   -1,
   -1,   -1,  294,  295,  296,  297,   -1,  299,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,  257,  258,   -1,   -1,  261,  262,  263,  264,
  265,   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  289,   -1,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  257,  258,   -1,   -1,  261,
  262,  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,   -1,   -1,  261,  262,   -1,  289,   -1,   -1,
  292,  293,  294,  295,  296,  297,   -1,  299,   -1,  256,
  257,  258,   -1,   -1,  261,  262,   -1,   -1,   -1,   -1,
   -1,   -1,  289,   -1,   -1,   -1,   -1,  294,  295,  296,
  297,   -1,  299,  257,  258,   -1,   -1,  261,  262,   -1,
   -1,   -1,  289,   -1,   -1,   -1,   -1,  294,  295,  296,
  297,   -1,  299,  257,  258,   -1,   -1,  261,  262,   -1,
   -1,   -1,   -1,   -1,   -1,  289,   -1,   -1,   -1,   -1,
  294,  295,  296,  297,  256,  299,   -1,   -1,   -1,   -1,
   -1,  263,  264,   -1,   -1,  289,  268,   -1,   -1,   -1,
  294,  295,  296,  297,   33,  299,   -1,   36,   37,   -1,
   -1,   40,   41,   42,   43,   44,   45,   -1,   47,  291,
  292,  293,   41,   -1,   -1,   44,  298,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   58,
   59,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    5,   -1,   -1,  123,   -1,   -1,   -1,   -1,   -1,
   15,   16,   17,   -1,  123,   -1,   21,   22,   -1,   24,
   25,   -1,   26,   -1,   -1,   -1,   31,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,
   -1,   -1,   -1,   47,   48,   -1,   -1,   -1,   -1,   53,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   72,   -1,
   74,   -1,   76,   77,   78,   79,   -1,   -1,   82,   -1,
   -1,   86,   87,   88,   89,   90,   91,   92,   93,   94,
   95,   96,   97,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  109,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  119,   -1,   -1,  122,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  135,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
   -1,   -1,  261,  262,  263,  264,  265,  256,   -1,  268,
   -1,   -1,   -1,   -1,   -1,  264,   -1,   -1,   -1,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  173,
  289,   -1,  291,  292,  293,   -1,   -1,  296,  297,  298,
  184,   -1,  291,  292,  293,   -1,   -1,  191,  192,  298,
   -1,  195,  196,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  207,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  218,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  227,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  251,   -1,  253,
  255,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  263,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 300
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,"'$'","'%'",0,0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'",0,"'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"FUNC_CALL","NAME","REGEXP",
"ERROR","YNUMBER","YSTRING","RELOP","IO_OUT","IO_IN","ASSIGNOP","ASSIGN",
"MATCHOP","CONCAT_OP","LEX_BEGIN","LEX_END","LEX_IF","LEX_ELSE","LEX_RETURN",
"LEX_DELETE","LEX_SWITCH","LEX_CASE","LEX_DEFAULT","LEX_WHILE","LEX_DO",
"LEX_FOR","LEX_BREAK","LEX_CONTINUE","LEX_PRINT","LEX_PRINTF","LEX_NEXT",
"LEX_EXIT","LEX_FUNCTION","LEX_GETLINE","LEX_NEXTFILE","LEX_IN","LEX_AND",
"LEX_OR","INCREMENT","DECREMENT","LEX_BUILTIN","LEX_LENGTH","NEWLINE",
"SLASH_BEFORE_EQUAL","UNARY",
};
char *yyrule[] = {
"$accept : start",
"start : opt_nls program opt_nls",
"program :",
"program : program rule",
"program : program error",
"rule : pattern action",
"rule : pattern statement_term",
"rule : function_prologue action",
"pattern :",
"pattern : exp",
"pattern : exp ',' exp",
"pattern : LEX_BEGIN",
"pattern : LEX_END",
"action : l_brace statements r_brace opt_semi opt_nls",
"func_name : NAME",
"func_name : FUNC_CALL",
"func_name : lex_builtin",
"lex_builtin : LEX_BUILTIN",
"lex_builtin : LEX_LENGTH",
"$$1 :",
"function_prologue : LEX_FUNCTION $$1 func_name '(' opt_param_list r_paren opt_nls",
"$$2 :",
"regexp : a_slash $$2 REGEXP",
"a_slash : '/'",
"a_slash : SLASH_BEFORE_EQUAL",
"statements :",
"statements : statements statement",
"statements : statements error",
"statement_term : nls",
"statement_term : semi opt_nls",
"statement : semi opt_nls",
"statement : l_brace statements r_brace",
"statement : if_statement",
"statement : LEX_SWITCH '(' exp r_paren opt_nls l_brace switch_body opt_nls r_brace",
"statement : LEX_WHILE '(' exp r_paren opt_nls statement",
"statement : LEX_DO opt_nls statement LEX_WHILE '(' exp r_paren opt_nls",
"statement : LEX_FOR '(' NAME LEX_IN NAME r_paren opt_nls statement",
"statement : LEX_FOR '(' opt_simple_stmt semi opt_nls exp semi opt_nls opt_simple_stmt r_paren opt_nls statement",
"statement : LEX_FOR '(' opt_simple_stmt semi opt_nls semi opt_nls opt_simple_stmt r_paren opt_nls statement",
"statement : LEX_BREAK statement_term",
"statement : LEX_CONTINUE statement_term",
"statement : LEX_NEXT statement_term",
"statement : LEX_NEXTFILE statement_term",
"statement : LEX_EXIT opt_exp statement_term",
"$$3 :",
"statement : LEX_RETURN $$3 opt_exp statement_term",
"statement : simple_stmt statement_term",
"$$4 :",
"simple_stmt : print $$4 print_expression_list output_redir",
"simple_stmt : LEX_DELETE NAME '[' expression_list ']'",
"simple_stmt : LEX_DELETE NAME",
"simple_stmt : LEX_DELETE '(' NAME ')'",
"simple_stmt : exp",
"opt_simple_stmt :",
"opt_simple_stmt : simple_stmt",
"switch_body : case_statements",
"case_statements :",
"case_statements : case_statements case_statement",
"case_statements : case_statements error",
"case_statement : LEX_CASE case_value colon opt_nls statements",
"case_statement : LEX_DEFAULT colon opt_nls statements",
"case_value : YNUMBER",
"case_value : '-' YNUMBER",
"case_value : '+' YNUMBER",
"case_value : YSTRING",
"case_value : regexp",
"print : LEX_PRINT",
"print : LEX_PRINTF",
"print_expression_list : opt_expression_list",
"print_expression_list : '(' expression_list r_paren",
"output_redir :",
"$$5 :",
"output_redir : IO_OUT $$5 common_exp",
"if_statement : LEX_IF '(' exp r_paren opt_nls statement",
"if_statement : LEX_IF '(' exp r_paren opt_nls statement LEX_ELSE opt_nls statement",
"nls : NEWLINE",
"nls : nls NEWLINE",
"opt_nls :",
"opt_nls : nls",
"input_redir :",
"input_redir : '<' simp_exp",
"opt_param_list :",
"opt_param_list : param_list",
"param_list : NAME",
"param_list : param_list comma NAME",
"param_list : error",
"param_list : param_list error",
"param_list : param_list comma error",
"opt_exp :",
"opt_exp : exp",
"opt_expression_list :",
"opt_expression_list : expression_list",
"expression_list : exp",
"expression_list : expression_list comma exp",
"expression_list : error",
"expression_list : expression_list error",
"expression_list : expression_list error exp",
"expression_list : expression_list comma error",
"exp : variable assign_operator exp",
"exp : exp LEX_AND exp",
"exp : exp LEX_OR exp",
"exp : exp MATCHOP exp",
"exp : exp LEX_IN NAME",
"exp : exp a_relop exp",
"exp : exp '?' exp ':' exp",
"exp : common_exp",
"assign_operator : ASSIGN",
"assign_operator : ASSIGNOP",
"assign_operator : SLASH_BEFORE_EQUAL ASSIGN",
"relop_or_less : RELOP",
"relop_or_less : '<'",
"a_relop : relop_or_less",
"a_relop : '>'",
"common_exp : simp_exp",
"common_exp : simp_exp_nc",
"common_exp : common_exp simp_exp",
"simp_exp : non_post_simp_exp",
"simp_exp : simp_exp '^' simp_exp",
"simp_exp : simp_exp '*' simp_exp",
"simp_exp : simp_exp '/' simp_exp",
"simp_exp : simp_exp '%' simp_exp",
"simp_exp : simp_exp '+' simp_exp",
"simp_exp : simp_exp '-' simp_exp",
"simp_exp : LEX_GETLINE opt_variable input_redir",
"simp_exp : variable INCREMENT",
"simp_exp : variable DECREMENT",
"simp_exp : '(' expression_list r_paren LEX_IN NAME",
"simp_exp_nc : common_exp IO_IN LEX_GETLINE opt_variable",
"simp_exp_nc : simp_exp_nc '^' simp_exp",
"simp_exp_nc : simp_exp_nc '*' simp_exp",
"simp_exp_nc : simp_exp_nc '/' simp_exp",
"simp_exp_nc : simp_exp_nc '%' simp_exp",
"simp_exp_nc : simp_exp_nc '+' simp_exp",
"simp_exp_nc : simp_exp_nc '-' simp_exp",
"non_post_simp_exp : regexp",
"non_post_simp_exp : '!' simp_exp",
"non_post_simp_exp : '(' exp r_paren",
"non_post_simp_exp : LEX_BUILTIN '(' opt_expression_list r_paren",
"non_post_simp_exp : LEX_LENGTH '(' opt_expression_list r_paren",
"non_post_simp_exp : LEX_LENGTH",
"non_post_simp_exp : FUNC_CALL '(' opt_expression_list r_paren",
"non_post_simp_exp : variable",
"non_post_simp_exp : INCREMENT variable",
"non_post_simp_exp : DECREMENT variable",
"non_post_simp_exp : YNUMBER",
"non_post_simp_exp : YSTRING",
"non_post_simp_exp : '-' simp_exp",
"non_post_simp_exp : '+' simp_exp",
"opt_variable :",
"opt_variable : variable",
"variable : NAME",
"variable : NAME '[' expression_list ']'",
"variable : field_spec",
"field_spec : '$' non_post_simp_exp opt_incdec",
"opt_incdec : INCREMENT",
"opt_incdec : DECREMENT",
"opt_incdec :",
"l_brace : '{' opt_nls",
"r_brace : '}' opt_nls",
"r_paren : ')'",
"opt_semi :",
"opt_semi : semi",
"semi : ';'",
"colon : ':'",
"comma : ',' opt_nls",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 1080 "awkgram.y"

struct token {
	const char *operator;		/* text to match */
	NODETYPE value;		/* node type */
	int class;		/* lexical class */
	unsigned flags;		/* # of args. allowed and compatability */
#	define	ARGS	0xFF	/* 0, 1, 2, 3 args allowed (any combination */
#	define	A(n)	(1<<(n))
#	define	VERSION_MASK	0xFF00	/* old awk is zero */
#	define	NOT_OLD		0x0100	/* feature not in old awk */
#	define	NOT_POSIX	0x0200	/* feature not in POSIX */
#	define	GAWKX		0x0400	/* gawk extension */
#	define	RESX		0x0800	/* Bell Labs Research extension */
	NODE *(*ptr) P((NODE *));	/* function that implements this keyword */
};

#if 'a' == 0x81 /* it's EBCDIC */
/* tokcompare --- lexicographically compare token names for sorting */

static int
tokcompare(void *l, void *r)
{
	struct token *lhs, *rhs;

	lhs = (struct token *) l;
	rhs = (struct token *) r;

	return strcmp(lhs->operator, rhs->operator);
}
#endif

/*
 * Tokentab is sorted ASCII ascending order, so it can be binary searched.
 * See check_special(), which sorts the table on EBCDIC systems.
 * Function pointers come from declarations in awk.h.
 */

static const struct token tokentab[] = {
{"BEGIN",	Node_illegal,	 LEX_BEGIN,	0,		0},
{"END",		Node_illegal,	 LEX_END,	0,		0},
#ifdef ARRAYDEBUG
{"adump",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(1),	do_adump},
#endif
{"and",		Node_builtin,    LEX_BUILTIN,	GAWKX|A(2),	do_and},
{"asort",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1)|A(2),	do_asort},
{"asorti",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1)|A(2),	do_asorti},
{"atan2",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(2),	do_atan2},
{"bindtextdomain",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1)|A(2),	do_bindtextdomain},
{"break",	Node_K_break,	 LEX_BREAK,	0,		0},
#ifdef ALLOW_SWITCH
{"case",	Node_K_case,	 LEX_CASE,	GAWKX,		0},
#endif
{"close",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1)|A(2),	do_close},
{"compl",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(1),	do_compl},
{"continue",	Node_K_continue, LEX_CONTINUE,	0,		0},
{"cos",		Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1),	do_cos},
{"dcgettext",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1)|A(2)|A(3),	do_dcgettext},
{"dcngettext",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1)|A(2)|A(3)|A(4)|A(5),	do_dcngettext},
#ifdef ALLOW_SWITCH
{"default",	Node_K_default,	 LEX_DEFAULT,	GAWKX,		0},
#endif
{"delete",	Node_K_delete,	 LEX_DELETE,	NOT_OLD,	0},
{"do",		Node_K_do,	 LEX_DO,	NOT_OLD,	0},
{"else",	Node_illegal,	 LEX_ELSE,	0,		0},
{"exit",	Node_K_exit,	 LEX_EXIT,	0,		0},
{"exp",		Node_builtin,	 LEX_BUILTIN,	A(1),		do_exp},
{"extension",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(2),	do_ext},
{"fflush",	Node_builtin,	 LEX_BUILTIN,	RESX|A(0)|A(1), do_fflush},
{"for",		Node_K_for,	 LEX_FOR,	0,		0},
{"func",	Node_K_function, LEX_FUNCTION,	NOT_POSIX|NOT_OLD,	0},
{"function",	Node_K_function, LEX_FUNCTION,	NOT_OLD,	0},
{"gensub",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(3)|A(4), do_gensub},
{"getline",	Node_K_getline,	 LEX_GETLINE,	NOT_OLD,	0},
{"gsub",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(2)|A(3), do_gsub},
{"if",		Node_K_if,	 LEX_IF,	0,		0},
{"in",		Node_illegal,	 LEX_IN,	0,		0},
{"index",	Node_builtin,	 LEX_BUILTIN,	A(2),		do_index},
{"int",		Node_builtin,	 LEX_BUILTIN,	A(1),		do_int},
{"length",	Node_builtin,	 LEX_LENGTH,	A(0)|A(1),	do_length},
{"log",		Node_builtin,	 LEX_BUILTIN,	A(1),		do_log},
{"lshift",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(2),	do_lshift},
{"match",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(2)|A(3), do_match},
{"mktime",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(1),	do_mktime},
{"next",	Node_K_next,	 LEX_NEXT,	0,		0},
{"nextfile",	Node_K_nextfile, LEX_NEXTFILE,	GAWKX,		0},
{"or",		Node_builtin,    LEX_BUILTIN,	GAWKX|A(2),	do_or},
{"print",	Node_K_print,	 LEX_PRINT,	0,		0},
{"printf",	Node_K_printf,	 LEX_PRINTF,	0,		0},
{"rand",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(0),	do_rand},
{"return",	Node_K_return,	 LEX_RETURN,	NOT_OLD,	0},
{"rshift",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(2),	do_rshift},
{"sin",		Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1),	do_sin},
{"split",	Node_builtin,	 LEX_BUILTIN,	A(2)|A(3),	do_split},
{"sprintf",	Node_builtin,	 LEX_BUILTIN,	0,		do_sprintf},
{"sqrt",	Node_builtin,	 LEX_BUILTIN,	A(1),		do_sqrt},
{"srand",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(0)|A(1), do_srand},
#if defined(GAWKDEBUG) || defined(ARRAYDEBUG) /* || ... */
{"stopme",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(0),	stopme},
#endif
{"strftime",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(0)|A(1)|A(2)|A(3), do_strftime},
{"strtonum",	Node_builtin,    LEX_BUILTIN,	GAWKX|A(1),	do_strtonum},
{"sub",		Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(2)|A(3), do_sub},
{"substr",	Node_builtin,	 LEX_BUILTIN,	A(2)|A(3),	do_substr},
#ifdef ALLOW_SWITCH
{"switch",	Node_K_switch,	 LEX_SWITCH,	GAWKX,		0},
#endif
{"system",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1),	do_system},
{"systime",	Node_builtin,	 LEX_BUILTIN,	GAWKX|A(0),	do_systime},
{"tolower",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1),	do_tolower},
{"toupper",	Node_builtin,	 LEX_BUILTIN,	NOT_OLD|A(1),	do_toupper},
{"while",	Node_K_while,	 LEX_WHILE,	0,		0},
{"xor",		Node_builtin,    LEX_BUILTIN,	GAWKX|A(2),	do_xor},
};

#ifdef MBS_SUPPORT
/* Variable containing the current shift state.  */
static mbstate_t cur_mbstate;
/* Ring buffer containing current characters.  */
#define MAX_CHAR_IN_RING_BUFFER 8
#define RING_BUFFER_SIZE (MAX_CHAR_IN_RING_BUFFER * MB_LEN_MAX)
static char cur_char_ring[RING_BUFFER_SIZE];
/* Index for ring buffers.  */
static int cur_ring_idx;
/* This macro means that last nextc() return a singlebyte character
   or 1st byte of a multibyte character.  */
#define nextc_is_1stbyte (cur_char_ring[cur_ring_idx] == 1)
#else /* MBS_SUPPORT */
/* a dummy */
#define nextc_is_1stbyte 1
#endif /* MBS_SUPPORT */

/* getfname --- return name of a builtin function (for pretty printing) */

const char *
getfname(register NODE *(*fptr)(NODE *))
{
	register int i, j;

	j = sizeof(tokentab) / sizeof(tokentab[0]);
	/* linear search, no other way to do it */
	for (i = 0; i < j; i++) 
		if (tokentab[i].ptr == fptr)
			return tokentab[i].operator;

	return NULL;
}

/* yyerror --- print a syntax error message, show where */

/*
 * Function identifier purposely indented to avoid mangling
 * by ansi2knr.  Sigh.
 */

static void
#ifdef CAN_USE_STDARG_H
  yyerror(const char *m, ...)
#else
/* VARARGS0 */
  yyerror(va_alist)
  va_dcl
#endif
{
	va_list args;
	const char *mesg = NULL;
	register char *bp, *cp;
	char *scan;
	char *buf;
	int count;
	static char end_of_file_line[] = "(END OF FILE)";
	char save;

	errcount++;
	/* Find the current line in the input file */
	if (lexptr && lexeme) {
		if (thisline == NULL) {
			cp = lexeme;
			if (*cp == '\n') {
				cp--;
				mesg = _("unexpected newline or end of string");
			}
			for (; cp != lexptr_begin && *cp != '\n'; --cp)
				continue;
			if (*cp == '\n')
				cp++;
			thisline = cp;
		}
		/* NL isn't guaranteed */
		bp = lexeme;
		while (bp < lexend && *bp && *bp != '\n')
			bp++;
	} else {
		thisline = end_of_file_line;
		bp = thisline + strlen(thisline);
	}

	/*
	 * Saving and restoring *bp keeps valgrind happy,
	 * since the guts of glibc uses strlen, even though
	 * we're passing an explict precision. Sigh.
	 *
	 * 8/2003: We may not need this anymore.
	 */
	save = *bp;
	*bp = '\0';

	msg("%.*s", (int) (bp - thisline), thisline);

	*bp = save;

#ifdef CAN_USE_STDARG_H
	va_start(args, m);
	if (mesg == NULL)
		mesg = m;
#else
	va_start(args);
	if (mesg == NULL)
		mesg = va_arg(args, char *);
#endif
	count = (bp - thisline) + strlen(mesg) + 2 + 1;
	emalloc(buf, char *, count, "yyerror");

	bp = buf;

	if (lexptr != NULL) {
		scan = thisline;
		while (scan < lexeme)
			if (*scan++ == '\t')
				*bp++ = '\t';
			else
				*bp++ = ' ';
		*bp++ = '^';
		*bp++ = ' ';
	}
	strcpy(bp, mesg);
	err("", buf, args);
	va_end(args);
	free(buf);
}

/* get_src_buf --- read the next buffer of source program */

static char *
get_src_buf()
{
	static int samefile = FALSE;
	static int nextfile = 0;
	static char *buf = NULL;
	static size_t buflen = 0;
	static int fd;

	/*
	 * No argument prototype on readfunc on purpose,
	 * avoids problems with some ancient systems where
	 * the types of arguments to read() aren't up to date.
	 */
	static ssize_t (*readfunc)() = 0;
	static int (*closefunc)P((int fd)) = NULL;

	int n;
	register char *scan;
	int newfile;
	struct stat sbuf;
	int readcount = 0;
	int l;
	char *readloc;

	if (readfunc == NULL) {
		char *cp = getenv("AWKREADFUNC");

		/* If necessary, one day, test value for different functions.  */
		if (cp == NULL) {
			readfunc = read;
			closefunc = close;
		} else {
			readfunc = read_one_line;
			closefunc = one_line_close;
		}
	}

again:
	newfile = FALSE;
	if (nextfile > numfiles)
		return NULL;

	if (srcfiles[nextfile].stype == CMDLINE) {
		if ((l = strlen(srcfiles[nextfile].val)) == 0) {
			/*
			 * Yet Another Special case:
			 *	gawk '' /path/name
			 * Sigh.
			 */
			static short warned = FALSE;

			if (do_lint && ! warned) {
				warned = TRUE;
				lintwarn(_("empty program text on command line"));
			}
			++nextfile;
			goto again;
		}
		if (srcfiles[nextfile].val[l-1] == '\n') {
			/* has terminating newline, can use it directly */
			sourceline = 1;
			source = NULL;
			lexptr = lexptr_begin = srcfiles[nextfile].val;
			/* fall through to pointer adjustment and return, below */
		} else {
			/* copy it into static buffer */

			/* make sure buffer exists and has room */
			if (buflen == 0) {
				emalloc(buf, char *, l+2, "get_src_buf");
				buflen = l + 2;
			} else if (l+2 > buflen) {
				erealloc(buf, char *, l+2, "get_src_buf");
				buflen = l + 2;
			} /* else
				buffer has room, just use it */

			/* copy in data */
			memcpy(buf, srcfiles[nextfile].val, l);
			buf[l] = '\n';
			buf[++l] = '\0';

			/* set vars and return */
			sourceline = 0;
			source = NULL;
			lexptr = lexptr_begin = buf;
		}
		lexend = lexptr + l;
		nextfile++;	/* for next entry to this routine */
		return lexptr;
	}

	if (! samefile) {
		source = srcfiles[nextfile].val;
		if (source == NULL) {	/* read all the source files, all done */
			if (buf != NULL) {
				free(buf);
				buf = NULL;
			}
			buflen = 0;
			return lexeme = lexptr = lexptr_begin = NULL;
		}
		fd = pathopen(source);
		if (fd <= INVALID_HANDLE) {
			char *in;

			/* suppress file name and line no. in error mesg */
			in = source;
			source = NULL;
			fatal(_("can't open source file `%s' for reading (%s)"),
				in, strerror(errno));
		}
		l = optimal_bufsize(fd, & sbuf);
		/*
		 * Make sure that something silly like
		 * 	AWKBUFSIZE=8 make check
		 * works ok.
		 */
#define A_DECENT_BUFFER_SIZE	128
		if (l < A_DECENT_BUFFER_SIZE)
			l = A_DECENT_BUFFER_SIZE;
#undef A_DECENT_BUFFER_SIZE

		newfile = TRUE;

		/* make sure buffer exists and has room */
		if (buflen == 0) {
			emalloc(buf, char *, l+2, "get_src_buf");
			buflen = l + 2;
		} else if (l+2 > buflen) {
			erealloc(buf, char *, l+2, "get_src_buf");
			buflen = l + 2;
		} /* else
			buffer has room, just use it */

		readcount = l;
		readloc = lexeme = lexptr = lexptr_begin = buf;
		samefile = TRUE;
		sourceline = 1;
	} else {
		/*
		 * In same file, ran off edge of buffer.
		 * Shift current line down to front, adjust
		 * pointers and fill in the rest of the buffer.
		 */

		int lexeme_offset = lexeme - lexptr_begin;
		int lexptr_offset = lexptr - lexptr_begin;
		int lexend_offset = lexend - lexptr_begin;

		/* find beginning of current line */
		for (scan = lexeme; scan >= lexptr_begin; scan--) {
			if (*scan == '\n') {
				scan++;
				break;
			}
		}

		/*
		 * This condition can be read as follows: IF
		 * 1. The beginning of the line is at the beginning of the
		 *    buffer (no newline was found: scan <= buf)
		 * AND:
		 *    2. The start of valid lexical data is into the buffer
		 *       (lexptr_begin > buf)
		 *       OR:
		 *       3. We have scanned past the end of the last data read
		 *          (lexptr == lexend)
		 *          AND:
		 *          4. There's no room left in the buffer
		 *             (lexptr_offset >= buflen - 2)
		 *
		 * If all that's true, grow the buffer to add more to
		 * the current line.
		 */

		if (scan <= buf
		    && (lexptr_begin > buf
			|| (lexptr == lexend
			    && lexptr_offset >= buflen - 2))) {
			/* have to grow the buffer */
			buflen *= 2;
			erealloc(buf, char *, buflen, "get_src_buf");
		} else if (scan > buf) {
			/* Line starts in middle of the buffer, shift things down. */
			memmove(buf, scan, lexend - scan);
			/*
			 * make offsets relative to start of line,
			 * not start of buffer.
			 */
			lexend_offset = lexend - scan;
			lexeme_offset = lexeme - scan;
			lexptr_offset = lexptr - scan;
		}

		/* adjust pointers */
		lexeme = buf + lexeme_offset;
		lexptr = buf + lexptr_offset;
		lexend = buf + lexend_offset;
		lexptr_begin = buf;
		readcount = buflen - (lexend - buf);
		readloc = lexend;
	}

	/* add more data to buffer */
	n = (*readfunc)(fd, readloc, readcount);
	if (n == -1)
		fatal(_("can't read sourcefile `%s' (%s)"),
			source, strerror(errno));
	if (n == 0) {
		if (newfile) {
			static short warned = FALSE;

			if (do_lint && ! warned) {
				warned = TRUE;
				lintwarn(_("source file `%s' is empty"), source);
			}
		}
		if (fd != fileno(stdin)) /* safety */
			(*closefunc)(fd);
		samefile = FALSE;
		nextfile++;
		goto again;
	}
	lexend = lexptr + n;
	return lexptr;
}

/* tokadd --- add a character to the token buffer */

#define	tokadd(x) (*tok++ = (x), tok == tokend ? tokexpand() : tok)

/* tokexpand --- grow the token buffer */

char *
tokexpand()
{
	static int toksize = 60;
	int tokoffset;

	tokoffset = tok - tokstart;
	toksize *= 2;
	if (tokstart != NULL)
		erealloc(tokstart, char *, toksize, "tokexpand");
	else
		emalloc(tokstart, char *, toksize, "tokexpand");
	tokend = tokstart + toksize;
	tok = tokstart + tokoffset;
	return tok;
}

/* nextc --- get the next input character */

#ifdef MBS_SUPPORT

static int
nextc(void)
{
	if (gawk_mb_cur_max > 1) {
		if (!lexptr || lexptr >= lexend) {
			if (! get_src_buf())
				return EOF;
		}

		/* Update the buffer index.  */
		cur_ring_idx = (cur_ring_idx == RING_BUFFER_SIZE - 1)? 0 :
			cur_ring_idx + 1;

		/* Did we already check the current character?  */
		if (cur_char_ring[cur_ring_idx] == 0) {
			/* No, we need to check the next character on the buffer.  */
			int idx, work_ring_idx = cur_ring_idx;
			mbstate_t tmp_state;
			size_t mbclen;

			for (idx = 0 ; lexptr + idx < lexend ; idx++) {
				tmp_state = cur_mbstate;
				mbclen = mbrlen(lexptr, idx + 1, &tmp_state);

				if (mbclen == 1 || mbclen == (size_t)-1 || mbclen == 0) {
					/* It is a singlebyte character, non-complete multibyte
					   character or EOF.  We treat it as a singlebyte
					   character.  */
					cur_char_ring[work_ring_idx] = 1;
					break;
				} else if (mbclen == (size_t)-2) {
					/* It is not a complete multibyte character.  */
					cur_char_ring[work_ring_idx] = idx + 1;
				} else {
					/* mbclen > 1 */
					cur_char_ring[work_ring_idx] = mbclen;
					break;
				}
				work_ring_idx = (work_ring_idx == RING_BUFFER_SIZE - 1)?
					0 : work_ring_idx + 1;
			}
			cur_mbstate = tmp_state;

			/* Put a mark on the position on which we write next character.  */
			work_ring_idx = (work_ring_idx == RING_BUFFER_SIZE - 1)?
				0 : work_ring_idx + 1;
			cur_char_ring[work_ring_idx] = 0;
		}

		return (int) (unsigned char) *lexptr++;
	}
	else {
		int c;

		if (lexptr && lexptr < lexend)
			c = (int) (unsigned char) *lexptr++;
		else if (get_src_buf())
			c = (int) (unsigned char) *lexptr++;
		else
			c = EOF;

		return c;
	}
}

#else /* MBS_SUPPORT */

#if GAWKDEBUG
int
nextc(void)
{
	int c;

	if (lexptr && lexptr < lexend)
		c = (int) (unsigned char) *lexptr++;
	else if (get_src_buf())
		c = (int) (unsigned char) *lexptr++;
	else
		c = EOF;

	return c;
}
#else
#define	nextc()	((lexptr && lexptr < lexend) ? \
		    ((int) (unsigned char) *lexptr++) : \
		    (get_src_buf() ? ((int) (unsigned char) *lexptr++) : EOF) \
		)
#endif

#endif /* MBS_SUPPORT */

/* pushback --- push a character back on the input */

static inline void
pushback(void)
{
#ifdef MBS_SUPPORT
	if (gawk_mb_cur_max > 1)
		cur_ring_idx = (cur_ring_idx == 0)? RING_BUFFER_SIZE - 1 :
			cur_ring_idx - 1;
#endif
	(lexptr && lexptr > lexptr_begin ? lexptr-- : lexptr);
}


/* allow_newline --- allow newline after &&, ||, ? and : */

static void
allow_newline(void)
{
	int c;

	for (;;) {
		c = nextc();
		if (c == EOF)
			break;
		if (c == '#') {
			while ((c = nextc()) != '\n' && c != EOF)
				continue;
			if (c == EOF)
				break;
		}
		if (c == '\n')
			sourceline++;
		if (! ISSPACE(c)) {
			pushback();
			break;
		}
	}
}

/* yylex --- Read the input and turn it into tokens. */

static int
yylex(void)
{
	register int c;
	int seen_e = FALSE;		/* These are for numbers */
	int seen_point = FALSE;
	int esc_seen;		/* for literal strings */
	int mid;
	static int did_newline = FALSE;
	char *tokkey;
	static int lasttok = 0;
	static short eof_warned = FALSE;
	int inhex = FALSE;
	int intlstr = FALSE;

	if (nextc() == EOF) {
		if (lasttok != NEWLINE) {
			lasttok = NEWLINE;
			if (do_lint && ! eof_warned) {
				lintwarn(_("source file does not end in newline"));
				eof_warned = TRUE;
			}
			return NEWLINE;	/* fake it */
		}
		return 0;
	}
	pushback();
#if defined OS2 || defined __EMX__
	/*
	 * added for OS/2's extproc feature of cmd.exe
	 * (like #! in BSD sh)
	 */
	if (strncasecmp(lexptr, "extproc ", 8) == 0) {
		while (*lexptr && *lexptr != '\n')
			lexptr++;
	}
#endif
	lexeme = lexptr;
	thisline = NULL;
	if (want_regexp) {
		int in_brack = 0;	/* count brackets, [[:alnum:]] allowed */
		/*
		 * Counting brackets is non-trivial. [[] is ok,
		 * and so is [\]], with a point being that /[/]/ as a regexp
		 * constant has to work.
		 *
		 * Do not count [ or ] if either one is preceded by a \.
		 * A `[' should be counted if
		 *  a) it is the first one so far (in_brack == 0)
		 *  b) it is the `[' in `[:'
		 * A ']' should be counted if not preceded by a \, since
		 * it is either closing `:]' or just a plain list.
		 * According to POSIX, []] is how you put a ] into a set.
		 * Try to handle that too.
		 *
		 * The code for \ handles \[ and \].
		 */

		want_regexp = FALSE;
		tok = tokstart;
		for (;;) {
			c = nextc();

			if (gawk_mb_cur_max == 1 || nextc_is_1stbyte) switch (c) {
			case '[':
				/* one day check for `.' and `=' too */
				if (nextc() == ':' || in_brack == 0)
					in_brack++;
				pushback();
				break;
			case ']':
				if (tokstart[0] == '['
				    && (tok == tokstart + 1
					|| (tok == tokstart + 2
					    && tokstart[1] == '^')))
					/* do nothing */;
				else
					in_brack--;
				break;
			case '\\':
				if ((c = nextc()) == EOF) {
					yyerror(_("unterminated regexp ends with `\\' at end of file"));
					goto end_regexp; /* kludge */
				} else if (c == '\n') {
					sourceline++;
					continue;
				} else {
					tokadd('\\');
					tokadd(c);
					continue;
				}
				break;
			case '/':	/* end of the regexp */
				if (in_brack > 0)
					break;
end_regexp:
				tokadd('\0');
				yylval.sval = tokstart;
				if (do_lint) {
					int peek = nextc();

					pushback();
					if (peek == 'i' || peek == 's') {
						if (source)
							lintwarn(
						_("%s: %d: tawk regex modifier `/.../%c' doesn't work in gawk"),
								source, sourceline, peek);
						else
							lintwarn(
						_("tawk regex modifier `/.../%c' doesn't work in gawk"),
								peek);
					}
				}
				return lasttok = REGEXP;
			case '\n':
				pushback();
				yyerror(_("unterminated regexp"));
				goto end_regexp;	/* kludge */
			case EOF:
				yyerror(_("unterminated regexp at end of file"));
				goto end_regexp;	/* kludge */
			}
			tokadd(c);
		}
	}
retry:

	/* skipping \r is a hack, but windows is just too pervasive. sigh. */
	while ((c = nextc()) == ' ' || c == '\t' || c == '\r')
		continue;

	lexeme = lexptr ? lexptr - 1 : lexptr;
	thisline = NULL;
	tok = tokstart;
	yylval.nodetypeval = Node_illegal;

	if (gawk_mb_cur_max == 1 || nextc_is_1stbyte) switch (c) {
	case EOF:
		if (lasttok != NEWLINE) {
			lasttok = NEWLINE;
			if (do_lint && ! eof_warned) {
				lintwarn(_("source file does not end in newline"));
				eof_warned = TRUE;
			}
			return NEWLINE;	/* fake it */
		}
		return 0;

	case '\n':
		sourceline++;
		return lasttok = NEWLINE;

	case '#':		/* it's a comment */
		while ((c = nextc()) != '\n') {
			if (c == EOF) {
				if (lasttok != NEWLINE) {
					lasttok = NEWLINE;
					if (do_lint && ! eof_warned) {
						lintwarn(
				_("source file does not end in newline"));
						eof_warned = TRUE;
					}
					return NEWLINE;	/* fake it */
				}
				return 0;
			}
		}
		sourceline++;
		return lasttok = NEWLINE;

	case '\\':
#ifdef RELAXED_CONTINUATION
		/*
		 * This code puports to allow comments and/or whitespace
		 * after the `\' at the end of a line used for continuation.
		 * Use it at your own risk. We think it's a bad idea, which
		 * is why it's not on by default.
		 */
		if (! do_traditional) {
			/* strip trailing white-space and/or comment */
			while ((c = nextc()) == ' ' || c == '\t' || c == '\r')
				continue;
			if (c == '#') {
				static short warned = FALSE;

				if (do_lint && ! warned) {
					warned = TRUE;
					lintwarn(
		_("use of `\\ #...' line continuation is not portable"));
				}
				while ((c = nextc()) != '\n')
					if (c == EOF)
						break;
			}
			pushback();
		}
#endif /* RELAXED_CONTINUATION */
		if (nextc() == '\n') {
			sourceline++;
			goto retry;
		} else {
			yyerror(_("backslash not last character on line"));
			exit(EXIT_FAILURE);
		}
		break;

	case ':':
	case '?':
		if (! do_posix)
			allow_newline();
		return lasttok = c;

		/*
		 * in_parens is undefined unless we are parsing a print
		 * statement (in_print), but why bother with a check?
		 */
	case ')':
		in_parens--;
		return lasttok = c;

	case '(':	
		in_parens++;
		/* FALL THROUGH */
	case '$':
	case ';':
	case '{':
	case ',':
	case '[':
	case ']':
		return lasttok = c;

	case '*':
		if ((c = nextc()) == '=') {
			yylval.nodetypeval = Node_assign_times;
			return lasttok = ASSIGNOP;
		} else if (do_posix) {
			pushback();
			return lasttok = '*';
		} else if (c == '*') {
			/* make ** and **= aliases for ^ and ^= */
			static int did_warn_op = FALSE, did_warn_assgn = FALSE;

			if (nextc() == '=') {
				if (! did_warn_assgn) {
					did_warn_assgn = TRUE;
					if (do_lint)
						lintwarn(_("POSIX does not allow operator `**='"));
					if (do_lint_old)
						warning(_("old awk does not support operator `**='"));
				}
				yylval.nodetypeval = Node_assign_exp;
				return ASSIGNOP;
			} else {
				pushback();
				if (! did_warn_op) {
					did_warn_op = TRUE;
					if (do_lint)
						lintwarn(_("POSIX does not allow operator `**'"));
					if (do_lint_old)
						warning(_("old awk does not support operator `**'"));
				}
				return lasttok = '^';
			}
		}
		pushback();
		return lasttok = '*';

	case '/':
		if (nextc() == '=') {
			pushback();
			return lasttok = SLASH_BEFORE_EQUAL;
		}
		pushback();
		return lasttok = '/';

	case '%':
		if (nextc() == '=') {
			yylval.nodetypeval = Node_assign_mod;
			return lasttok = ASSIGNOP;
		}
		pushback();
		return lasttok = '%';

	case '^':
	{
		static int did_warn_op = FALSE, did_warn_assgn = FALSE;

		if (nextc() == '=') {
			if (do_lint_old && ! did_warn_assgn) {
				did_warn_assgn = TRUE;
				warning(_("operator `^=' is not supported in old awk"));
			}
			yylval.nodetypeval = Node_assign_exp;
			return lasttok = ASSIGNOP;
		}
		pushback();
		if (do_lint_old && ! did_warn_op) {
			did_warn_op = TRUE;
			warning(_("operator `^' is not supported in old awk"));
		}
		return lasttok = '^';
	}

	case '+':
		if ((c = nextc()) == '=') {
			yylval.nodetypeval = Node_assign_plus;
			return lasttok = ASSIGNOP;
		}
		if (c == '+')
			return lasttok = INCREMENT;
		pushback();
		return lasttok = '+';

	case '!':
		if ((c = nextc()) == '=') {
			yylval.nodetypeval = Node_notequal;
			return lasttok = RELOP;
		}
		if (c == '~') {
			yylval.nodetypeval = Node_nomatch;
			return lasttok = MATCHOP;
		}
		pushback();
		return lasttok = '!';

	case '<':
		if (nextc() == '=') {
			yylval.nodetypeval = Node_leq;
			return lasttok = RELOP;
		}
		yylval.nodetypeval = Node_less;
		pushback();
		return lasttok = '<';

	case '=':
		if (nextc() == '=') {
			yylval.nodetypeval = Node_equal;
			return lasttok = RELOP;
		}
		yylval.nodetypeval = Node_assign;
		pushback();
		return lasttok = ASSIGN;

	case '>':
		if ((c = nextc()) == '=') {
			yylval.nodetypeval = Node_geq;
			return lasttok = RELOP;
		} else if (c == '>') {
			yylval.nodetypeval = Node_redirect_append;
			return lasttok = IO_OUT;
		}
		pushback();
		if (in_print && in_parens == 0) {
			yylval.nodetypeval = Node_redirect_output;
			return lasttok = IO_OUT;
		}
		yylval.nodetypeval = Node_greater;
		return lasttok = '>';

	case '~':
		yylval.nodetypeval = Node_match;
		return lasttok = MATCHOP;

	case '}':
		/*
		 * Added did newline stuff.  Easier than
		 * hacking the grammar.
		 */
		if (did_newline) {
			did_newline = FALSE;
			return lasttok = c;
		}
		did_newline++;
		--lexptr;	/* pick up } next time */
		return lasttok = NEWLINE;

	case '"':
	string:
		esc_seen = FALSE;
		while ((c = nextc()) != '"') {
			if (c == '\n') {
				pushback();
				yyerror(_("unterminated string"));
				exit(EXIT_FAILURE);
			}
			if ((gawk_mb_cur_max == 1 || nextc_is_1stbyte) &&
			    c == '\\') {
				c = nextc();
				if (c == '\n') {
					sourceline++;
					continue;
				}
				esc_seen = TRUE;
				tokadd('\\');
			}
			if (c == EOF) {
				pushback();
				yyerror(_("unterminated string"));
				exit(EXIT_FAILURE);
			}
			tokadd(c);
		}
		yylval.nodeval = make_str_node(tokstart,
					tok - tokstart, esc_seen ? SCAN : 0);
		yylval.nodeval->flags |= PERM;
		if (intlstr) {
			yylval.nodeval->flags |= INTLSTR;
			intlstr = FALSE;
			if (do_intl)
				dumpintlstr(yylval.nodeval->stptr,
						yylval.nodeval->stlen);
 		}
		return lasttok = YSTRING;

	case '-':
		if ((c = nextc()) == '=') {
			yylval.nodetypeval = Node_assign_minus;
			return lasttok = ASSIGNOP;
		}
		if (c == '-')
			return lasttok = DECREMENT;
		pushback();
		return lasttok = '-';

	case '.':
		c = nextc();
		pushback();
		if (! ISDIGIT(c))
			return lasttok = '.';
		else
			c = '.';
		/* FALL THROUGH */
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
		/* It's a number */
		for (;;) {
			int gotnumber = FALSE;

			tokadd(c);
			switch (c) {
			case 'x':
			case 'X':
				if (do_traditional)
					goto done;
				if (tok == tokstart + 2) {
					int peek = nextc();

					if (ISXDIGIT(peek)) {
						inhex = TRUE;
						pushback();	/* following digit */
					} else {
						pushback();	/* x or X */
						goto done;
					}
				}
				break;
			case '.':
				/* period ends exponent part of floating point number */
				if (seen_point || seen_e) {
					gotnumber = TRUE;
					break;
				}
				seen_point = TRUE;
				break;
			case 'e':
			case 'E':
				if (inhex)
					break;
				if (seen_e) {
					gotnumber = TRUE;
					break;
				}
				seen_e = TRUE;
				if ((c = nextc()) == '-' || c == '+') {
					int c2 = nextc();

					if (ISDIGIT(c2)) {
						tokadd(c);
						tokadd(c2);
					} else {
						pushback();	/* non-digit after + or - */
						pushback();	/* + or - */
						pushback();	/* e or E */
					}
				} else if (! ISDIGIT(c)) {
					pushback();	/* character after e or E */
					pushback();	/* e or E */
				} else {
					pushback();	/* digit */
				}
				break;
			case 'a':
			case 'A':
			case 'b':
			case 'B':
			case 'c':
			case 'C':
			case 'D':
			case 'd':
			case 'f':
			case 'F':
				if (do_traditional || ! inhex)
					goto done;
				/* fall through */
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
				break;
			default:
			done:
				gotnumber = TRUE;
			}
			if (gotnumber)
				break;
			c = nextc();
		}
		if (c != EOF)
			pushback();
		else if (do_lint && ! eof_warned) {
			lintwarn(_("source file does not end in newline"));
			eof_warned = TRUE;
		}
		tokadd('\0');
		if (! do_traditional && isnondecimal(tokstart, FALSE)) {
			if (do_lint) {
				if (ISDIGIT(tokstart[1]))	/* not an 'x' or 'X' */
					lintwarn("numeric constant `%.*s' treated as octal",
						(int) strlen(tokstart)-1, tokstart);
				else if (tokstart[1] == 'x' || tokstart[1] == 'X')
					lintwarn("numeric constant `%.*s' treated as hexadecimal",
						(int) strlen(tokstart)-1, tokstart);
			}
			yylval.nodeval = make_number(nondec2awknum(tokstart, strlen(tokstart)));
		} else
			yylval.nodeval = make_number(atof(tokstart));
		yylval.nodeval->flags |= PERM;
		return lasttok = YNUMBER;

	case '&':
		if ((c = nextc()) == '&') {
			yylval.nodetypeval = Node_and;
			allow_newline();
			return lasttok = LEX_AND;
		}
		pushback();
		return lasttok = '&';

	case '|':
		if ((c = nextc()) == '|') {
			yylval.nodetypeval = Node_or;
			allow_newline();
			return lasttok = LEX_OR;
		} else if (! do_traditional && c == '&') {
			yylval.nodetypeval = Node_redirect_twoway;
			return lasttok = (in_print && in_parens == 0 ? IO_OUT : IO_IN);
		}
		pushback();
		if (in_print && in_parens == 0) {
			yylval.nodetypeval = Node_redirect_pipe;
			return lasttok = IO_OUT;
		} else {
			yylval.nodetypeval = Node_redirect_pipein;
			return lasttok = IO_IN;
		}
	}

	if (c != '_' && ! ISALPHA(c)) {
		yyerror(_("invalid char '%c' in expression"), c);
		exit(EXIT_FAILURE);
	}

	/*
	 * Lots of fog here.  Consider:
	 *
	 * print "xyzzy"$_"foo"
	 *
	 * Without the check for ` lasttok != '$' ', this is parsed as
	 *
	 * print "xxyzz" $(_"foo")
	 *
	 * With the check, it is "correctly" parsed as three
	 * string concatenations.  Sigh.  This seems to be
	 * "more correct", but this is definitely one of those
	 * occasions where the interactions are funny.
	 */
	if (! do_traditional && c == '_' && lasttok != '$') {
		if ((c = nextc()) == '"') {
			intlstr = TRUE;
			goto string;
		}
		pushback();
		c = '_';
	}

	/* it's some type of name-type-thing.  Find its length. */
	tok = tokstart;
	while (is_identchar(c)) {
		tokadd(c);
		c = nextc();
	}
	tokadd('\0');
	emalloc(tokkey, char *, tok - tokstart, "yylex");
	memcpy(tokkey, tokstart, tok - tokstart);
	if (c != EOF)
		pushback();
	else if (do_lint && ! eof_warned) {
		lintwarn(_("source file does not end in newline"));
		eof_warned = TRUE;
	}

	/* See if it is a special token. */

	if ((mid = check_special(tokstart)) >= 0) {
		if (do_lint) {
			if (tokentab[mid].flags & GAWKX)
				lintwarn(_("`%s' is a gawk extension"),
					tokentab[mid].operator);
			if (tokentab[mid].flags & RESX)
				lintwarn(_("`%s' is a Bell Labs extension"),
					tokentab[mid].operator);
			if (tokentab[mid].flags & NOT_POSIX)
				lintwarn(_("POSIX does not allow `%s'"),
					tokentab[mid].operator);
		}
		if (do_lint_old && (tokentab[mid].flags & NOT_OLD))
			warning(_("`%s' is not supported in old awk"),
					tokentab[mid].operator);
		if ((do_traditional && (tokentab[mid].flags & GAWKX))
		    || (do_posix && (tokentab[mid].flags & NOT_POSIX)))
			;
		else {
			if (tokentab[mid].class == LEX_BUILTIN
			    || tokentab[mid].class == LEX_LENGTH)
				yylval.lval = mid;
			else
				yylval.nodetypeval = tokentab[mid].value;
			free(tokkey);
			return lasttok = tokentab[mid].class;
		}
	}

	yylval.sval = tokkey;
	if (*lexptr == '(')
		return lasttok = FUNC_CALL;
	else {
		static short goto_warned = FALSE;

#define SMART_ALECK	1
		if (SMART_ALECK && do_lint
		    && ! goto_warned && strcasecmp(tokkey, "goto") == 0) {
			goto_warned = TRUE;
			lintwarn(_("`goto' considered harmful!\n"));
		}
		return lasttok = NAME;
	}
}

/* node_common --- common code for allocating a new node */

static NODE *
node_common(NODETYPE op)
{
	register NODE *r;

	getnode(r);
	r->type = op;
	r->flags = MALLOC;
	/* if lookahead is a NL, lineno is 1 too high */
	if (lexeme && lexeme >= lexptr_begin && *lexeme == '\n')
		r->source_line = sourceline - 1;
	else
		r->source_line = sourceline;
	r->source_file = source;
	return r;
}

/* node --- allocates a node with defined lnode and rnode. */

NODE *
node(NODE *left, NODETYPE op, NODE *right)
{
	register NODE *r;

	r = node_common(op);
	r->lnode = left;
	r->rnode = right;
	return r;
}

/* snode ---	allocate a node with defined subnode and builtin for builtin
		functions. Checks for arg. count and supplies defaults where
		possible. */

static NODE *
snode(NODE *subn, NODETYPE op, int idx)
{
	register NODE *r;
	register NODE *n;
	int nexp = 0;
	int args_allowed;

	r = node_common(op);

	/* traverse expression list to see how many args. given */
	for (n = subn; n != NULL; n = n->rnode) {
		nexp++;
		if (nexp > 5)
			break;
	}

	/* check against how many args. are allowed for this builtin */
	args_allowed = tokentab[idx].flags & ARGS;
	if (args_allowed && (args_allowed & A(nexp)) == 0)
		fatal(_("%d is invalid as number of arguments for %s"),
				nexp, tokentab[idx].operator);

	r->builtin = tokentab[idx].ptr;

	/* special case processing for a few builtins */
	if (nexp == 0 && r->builtin == do_length) {
		subn = node(node(make_number(0.0), Node_field_spec, (NODE *) NULL),
		            Node_expression_list,
			    (NODE *) NULL);
	} else if (r->builtin == do_match) {
		static short warned = FALSE;

		if (subn->rnode->lnode->type != Node_regex)
			subn->rnode->lnode = mk_rexp(subn->rnode->lnode);

		if (subn->rnode->rnode != NULL) {	/* 3rd argument there */
			if (do_lint && ! warned) {
				warned = TRUE;
				lintwarn(_("match: third argument is a gawk extension"));
			}
			if (do_traditional)
				fatal(_("match: third argument is a gawk extension"));
		}
	} else if (r->builtin == do_sub || r->builtin == do_gsub) {
		if (subn->lnode->type != Node_regex)
			subn->lnode = mk_rexp(subn->lnode);
		if (nexp == 2)
			append_right(subn, node(node(make_number(0.0),
						     Node_field_spec,
						     (NODE *) NULL),
					        Node_expression_list,
						(NODE *) NULL));
		else if (subn->rnode->rnode->lnode->type == Node_val) {
			if (do_lint)
				lintwarn(_("%s: string literal as last arg of substitute has no effect"),
					(r->builtin == do_sub) ? "sub" : "gsub");
		} else if (! isassignable(subn->rnode->rnode->lnode)) {
			yyerror(_("%s third parameter is not a changeable object"),
				(r->builtin == do_sub) ? "sub" : "gsub");
		}
	} else if (r->builtin == do_gensub) {
		if (subn->lnode->type != Node_regex)
			subn->lnode = mk_rexp(subn->lnode);
		if (nexp == 3)
			append_right(subn, node(node(make_number(0.0),
						     Node_field_spec,
						     (NODE *) NULL),
					        Node_expression_list,
						(NODE *) NULL));
	} else if (r->builtin == do_split) {
		if (nexp == 2)
			append_right(subn,
			    node(FS_node, Node_expression_list, (NODE *) NULL));
		n = subn->rnode->rnode->lnode;
		if (n->type != Node_regex)
			subn->rnode->rnode->lnode = mk_rexp(n);
		if (nexp == 2)
			subn->rnode->rnode->lnode->re_flags |= FS_DFLT;
	} else if (r->builtin == do_close) {
		static short warned = FALSE;

		if ( nexp == 2) {
			if (do_lint && nexp == 2 && ! warned) {
				warned = TRUE;
				lintwarn(_("close: second argument is a gawk extension"));
			}
			if (do_traditional)
				fatal(_("close: second argument is a gawk extension"));
		}
	} else if (do_intl					/* --gen-po */
			&& r->builtin == do_dcgettext		/* dcgettext(...) */
			&& subn->lnode->type == Node_val	/* 1st arg is constant */
			&& (subn->lnode->flags & STRCUR) != 0) {	/* it's a string constant */
		/* ala xgettext, dcgettext("some string" ...) dumps the string */
		NODE *str = subn->lnode;

		if ((str->flags & INTLSTR) != 0)
			warning(_("use of dcgettext(_\"...\") is incorrect: remove leading underscore"));
			/* don't dump it, the lexer already did */
		else
			dumpintlstr(str->stptr, str->stlen);
	} else if (do_intl					/* --gen-po */
			&& r->builtin == do_dcngettext		/* dcngettext(...) */
			&& subn->lnode->type == Node_val	/* 1st arg is constant */
			&& (subn->lnode->flags & STRCUR) != 0	/* it's a string constant */
			&& subn->rnode->lnode->type == Node_val	/* 2nd arg is constant too */
			&& (subn->rnode->lnode->flags & STRCUR) != 0) {	/* it's a string constant */
		/* ala xgettext, dcngettext("some string", "some plural" ...) dumps the string */
		NODE *str1 = subn->lnode;
		NODE *str2 = subn->rnode->lnode;

		if (((str1->flags | str2->flags) & INTLSTR) != 0)
			warning(_("use of dcngettext(_\"...\") is incorrect: remove leading underscore"));
		else
			dumpintlstr2(str1->stptr, str1->stlen, str2->stptr, str2->stlen);
	}

	r->subnode = subn;
	if (r->builtin == do_sprintf) {
		count_args(r);
		if (r->lnode != NULL)	/* r->lnode set from subn. guard against syntax errors & check it's valid */
			r->lnode->printf_count = r->printf_count; /* hack */
	}
	return r;
}

/* make_for_loop --- build a for loop */

static NODE *
make_for_loop(NODE *init, NODE *cond, NODE *incr)
{
	register FOR_LOOP_HEADER *r;
	NODE *n;

	emalloc(r, FOR_LOOP_HEADER *, sizeof(FOR_LOOP_HEADER), "make_for_loop");
	getnode(n);
	n->type = Node_illegal;
	r->init = init;
	r->cond = cond;
	r->incr = incr;
	n->sub.nodep.r.hd = r;
	return n;
}

/* dup_parms --- return TRUE if there are duplicate parameters */

static int
dup_parms(NODE *func)
{
	register NODE *np;
	const char *fname, **names;
	int count, i, j, dups;
	NODE *params;

	if (func == NULL)	/* error earlier */
		return TRUE;

	fname = func->param;
	count = func->param_cnt;
	params = func->rnode;

	if (count == 0)		/* no args, no problem */
		return FALSE;

	if (params == NULL)	/* error earlier */
		return TRUE;

	emalloc(names, const char **, count * sizeof(char *), "dup_parms");

	i = 0;
	for (np = params; np != NULL; np = np->rnode) {
		if (np->param == NULL) { /* error earlier, give up, go home */
			free(names);
			return TRUE;
		}
		names[i++] = np->param;
	}

	dups = 0;
	for (i = 1; i < count; i++) {
		for (j = 0; j < i; j++) {
			if (strcmp(names[i], names[j]) == 0) {
				dups++;
				error(
	_("function `%s': parameter #%d, `%s', duplicates parameter #%d"),
					fname, i+1, names[j], j+1);
			}
		}
	}

	free(names);
	return (dups > 0 ? TRUE : FALSE);
}

/* parms_shadow --- check if parameters shadow globals */

static int
parms_shadow(const char *fname, NODE *func)
{
	int count, i;
	int ret = FALSE;

	if (fname == NULL || func == NULL)	/* error earlier */
		return FALSE;

	count = func->lnode->param_cnt;

	if (count == 0)		/* no args, no problem */
		return FALSE;

	/*
	 * Use warning() and not lintwarn() so that can warn
	 * about all shadowed parameters.
	 */
	for (i = 0; i < count; i++) {
		if (lookup(func->parmlist[i]) != NULL) {
			warning(
	_("function `%s': parameter `%s' shadows global variable"),
					fname, func->parmlist[i]);
			ret = TRUE;
		}
	}

	return ret;
}

/*
 * install:
 * Install a name in the symbol table, even if it is already there.
 * Caller must check against redefinition if that is desired. 
 */

NODE *
install(char *name, NODE *value)
{
	register NODE *hp;
	register size_t len;
	register int bucket;

	var_count++;
	len = strlen(name);
	bucket = hash(name, len, (unsigned long) HASHSIZE, NULL);
	getnode(hp);
	hp->type = Node_hashnode;
	hp->hnext = variables[bucket];
	variables[bucket] = hp;
	hp->hlength = len;
	hp->hvalue = value;
	hp->hname = name;
	hp->hvalue->vname = name;
	return hp->hvalue;
}

/* lookup --- find the most recent hash node for name installed by install */

NODE *
lookup(const char *name)
{
	register NODE *bucket;
	register size_t len;

	len = strlen(name);
	for (bucket = variables[hash(name, len, (unsigned long) HASHSIZE, NULL)];
			bucket != NULL; bucket = bucket->hnext)
		if (bucket->hlength == len && STREQN(bucket->hname, name, len))
			return bucket->hvalue;

	return NULL;
}

/* var_comp --- compare two variable names */

static int
var_comp(const void *v1, const void *v2)
{
	const NODE *const *npp1, *const *npp2;
	const NODE *n1, *n2;
	int minlen;

	npp1 = (const NODE *const *) v1;
	npp2 = (const NODE *const *) v2;
	n1 = *npp1;
	n2 = *npp2;

	if (n1->hlength > n2->hlength)
		minlen = n1->hlength;
	else
		minlen = n2->hlength;

	return strncmp(n1->hname, n2->hname, minlen);
}

/* valinfo --- dump var info */

static void
valinfo(NODE *n, FILE *fp)
{
	if (n->flags & STRING) {
		fprintf(fp, "string (");
		pp_string_fp(fp, n->stptr, n->stlen, '"', FALSE);
		fprintf(fp, ")\n");
	} else if (n->flags & NUMBER)
		fprintf(fp, "number (%.17g)\n", n->numbr);
	else if (n->flags & STRCUR) {
		fprintf(fp, "string value (");
		pp_string_fp(fp, n->stptr, n->stlen, '"', FALSE);
		fprintf(fp, ")\n");
	} else if (n->flags & NUMCUR)
		fprintf(fp, "number value (%.17g)\n", n->numbr);
	else
		fprintf(fp, "?? flags %s\n", flags2str(n->flags));
}


/* dump_vars --- dump the symbol table */

void
dump_vars(const char *fname)
{
	int i, j;
	NODE **table;
	NODE *p;
	FILE *fp;

	emalloc(table, NODE **, var_count * sizeof(NODE *), "dump_vars");

	if (fname == NULL)
		fp = stderr;
	else if ((fp = fopen(fname, "w")) == NULL) {
		warning(_("could not open `%s' for writing (%s)"), fname, strerror(errno));
		warning(_("sending profile to standard error"));
		fp = stderr;
	}

	for (i = j = 0; i < HASHSIZE; i++)
		for (p = variables[i]; p != NULL; p = p->hnext)
			table[j++] = p;

	assert(j == var_count);

	/* Shazzam! */
	qsort(table, j, sizeof(NODE *), var_comp);

	for (i = 0; i < j; i++) {
		p = table[i];
		if (p->hvalue->type == Node_func)
			continue;
		fprintf(fp, "%.*s: ", (int) p->hlength, p->hname);
		if (p->hvalue->type == Node_var_array)
			fprintf(fp, "array, %ld elements\n", p->hvalue->table_size);
		else if (p->hvalue->type == Node_var_new)
			fprintf(fp, "unused variable\n");
		else if (p->hvalue->type == Node_var)
			valinfo(p->hvalue->var_value, fp);
		else {
			NODE **lhs = get_lhs(p->hvalue, NULL, FALSE);

			valinfo(*lhs, fp);
		}
	}

	if (fp != stderr && fclose(fp) != 0)
		warning(_("%s: close failed (%s)"), fname, strerror(errno));

	free(table);
}

/* release_all_vars --- free all variable memory */

void
release_all_vars()
{
	int i;
	NODE *p, *next;

	for (i = 0; i < HASHSIZE; i++)
		for (p = variables[i]; p != NULL; p = next) {
			next = p->hnext;

			if (p->hvalue->type == Node_func)
				continue;
			else if (p->hvalue->type == Node_var_array)
				assoc_clear(p->hvalue);
			else if (p->hvalue->type != Node_var_new) {
				NODE **lhs = get_lhs(p->hvalue, NULL, FALSE);

				unref(*lhs);
			}
			unref(p);
	}
}

/* finfo --- for use in comparison and sorting of function names */

struct finfo {
	const char *name;
	size_t nlen;
	NODE *func;
};

/* fcompare --- comparison function for qsort */

static int
fcompare(const void *p1, const void *p2)
{
	const struct finfo *f1, *f2;
	int minlen;

	f1 = (const struct finfo *) p1;
	f2 = (const struct finfo *) p2;

	if (f1->nlen > f2->nlen)
		minlen = f2->nlen;
	else
		minlen = f1->nlen;

	return strncmp(f1->name, f2->name, minlen);
}

/* dump_funcs --- print all functions */

void
dump_funcs()
{
	int i, j;
	NODE *p;
	struct finfo *tab = NULL;

	/*
	 * Walk through symbol table countng functions.
	 * Could be more than func_count if there are
	 * extension functions.
	 */
	for (i = j = 0; i < HASHSIZE; i++) {
		for (p = variables[i]; p != NULL; p = p->hnext) {
			if (p->hvalue->type == Node_func) {
				j++;
			}
		}
	}

	if (j == 0)
		return;

	emalloc(tab, struct finfo *, j * sizeof(struct finfo), "dump_funcs");

	/* now walk again, copying info */
	for (i = j = 0; i < HASHSIZE; i++) {
		for (p = variables[i]; p != NULL; p = p->hnext) {
			if (p->hvalue->type == Node_func) {
				tab[j].name = p->hname;
				tab[j].nlen = p->hlength;
				tab[j].func = p->hvalue;
				j++;
			}
		}
	}


	/* Shazzam! */
	qsort(tab, j, sizeof(struct finfo), fcompare);

	for (i = 0; i < j; i++)
		pp_func(tab[i].name, tab[i].nlen, tab[i].func);

	free(tab);
}

/* shadow_funcs --- check all functions for parameters that shadow globals */

void
shadow_funcs()
{
	int i, j;
	NODE *p;
	struct finfo *tab;
	static int calls = 0;
	int shadow = FALSE;

	if (func_count == 0)
		return;

	if (calls++ != 0)
		fatal(_("shadow_funcs() called twice!"));

	emalloc(tab, struct finfo *, func_count * sizeof(struct finfo), "shadow_funcs");

	for (i = j = 0; i < HASHSIZE; i++) {
		for (p = variables[i]; p != NULL; p = p->hnext) {
			if (p->hvalue->type == Node_func) {
				tab[j].name = p->hname;
				tab[j].nlen = p->hlength;
				tab[j].func = p->hvalue;
				j++;
			}
		}
	}

	assert(j == func_count);

	/* Shazzam! */
	qsort(tab, func_count, sizeof(struct finfo), fcompare);

	for (i = 0; i < j; i++)
		shadow |= parms_shadow(tab[i].name, tab[i].func);

	free(tab);

	/* End with fatal if the user requested it.  */
	if (shadow && lintfunc != warning)
		lintwarn(_("there were shadowed variables."));
}

/*
 * append_right:
 * Add new to the rightmost branch of LIST.  This uses n^2 time, so we make
 * a simple attempt at optimizing it.
 */

static NODE *
append_right(NODE *list, NODE *new)
{
	register NODE *oldlist;
	static NODE *savefront = NULL, *savetail = NULL;

	if (list == NULL || new == NULL)
		return list;

	oldlist = list;
	if (savefront == oldlist)
		list = savetail; /* Be careful: maybe list->rnode != NULL */
	else
		savefront = oldlist;

	while (list->rnode != NULL)
		list = list->rnode;
	savetail = list->rnode = new;
	return oldlist;
}

/*
 * append_pattern:
 * A wrapper around append_right, used for rule lists.
 */
static inline NODE *
append_pattern(NODE **list, NODE *patt)
{
	NODE *n = node(patt, Node_rule_node, (NODE *) NULL);

	if (*list == NULL)
		*list = n;
	else {
		NODE *n1 = node(n, Node_rule_list, (NODE *) NULL);
		if ((*list)->type != Node_rule_list)
			*list = node(*list, Node_rule_list, n1);
		else
			(void) append_right(*list, n1);
	}
	return n;
}

/*
 * func_install:
 * check if name is already installed;  if so, it had better have Null value,
 * in which case def is added as the value. Otherwise, install name with def
 * as value. 
 *
 * Extra work, build up and save a list of the parameter names in a table
 * and hang it off params->parmlist. This is used to set the `vname' field
 * of each function parameter during a function call. See eval.c.
 */

static void
func_install(NODE *params, NODE *def)
{
	NODE *r, *n, *thisfunc;
	char **pnames, *names, *sp;
	size_t pcount = 0, space = 0;
	int i;

	/* check for function foo(foo) { ... }.  bleah. */
	for (n = params->rnode; n != NULL; n = n->rnode) {
		if (strcmp(n->param, params->param) == 0)
			fatal(_("function `%s': can't use function name as parameter name"),
					params->param); 
		else if (is_std_var(n->param))
			fatal(_("function `%s': can't use special variable `%s' as a function parameter"),
				params->param, n->param);
	}

	thisfunc = NULL;	/* turn off warnings */

	/* symbol table managment */
	pop_var(params, FALSE);
	r = lookup(params->param);
	if (r != NULL) {
		fatal(_("function name `%s' previously defined"), params->param);
	} else if (params->param == builtin_func)	/* not a valid function name */
		goto remove_params;

	/* install the function */
	thisfunc = node(params, Node_func, def);
	(void) install(params->param, thisfunc);

	/* figure out amount of space to allocate for variable names */
	for (n = params->rnode; n != NULL; n = n->rnode) {
		pcount++;
		space += strlen(n->param) + 1;
	}

	/* allocate it and fill it in */
	if (pcount != 0) {
		emalloc(names, char *, space, "func_install");
		emalloc(pnames, char **, pcount * sizeof(char *), "func_install");
		sp = names;
		for (i = 0, n = params->rnode; i < pcount; i++, n = n->rnode) {
			pnames[i] = sp;
			strcpy(sp, n->param);
			sp += strlen(n->param) + 1;
		}
		thisfunc->parmlist = pnames;
	} else {
		thisfunc->parmlist = NULL;
	}

	/* update lint table info */
	func_use(params->param, FUNC_DEFINE);

	func_count++;	/* used by profiling / pretty printer */

remove_params:
	/* remove params from symbol table */
	pop_params(params->rnode);
}

/* pop_var --- remove a variable from the symbol table */

static void
pop_var(NODE *np, int freeit)
{
	register NODE *bucket, **save;
	register size_t len;
	char *name;

	name = np->param;
	len = strlen(name);
	save = &(variables[hash(name, len, (unsigned long) HASHSIZE, NULL)]);
	for (bucket = *save; bucket != NULL; bucket = bucket->hnext) {
		if (len == bucket->hlength && STREQN(bucket->hname, name, len)) {
			var_count--;
			*save = bucket->hnext;
			freenode(bucket);
			if (freeit)
				free(np->param);
			return;
		}
		save = &(bucket->hnext);
	}
}

/* pop_params --- remove list of function parameters from symbol table */

/*
 * pop parameters out of the symbol table. do this in reverse order to
 * avoid reading freed memory if there were duplicated parameters.
 */
static void
pop_params(NODE *params)
{
	if (params == NULL)
		return;
	pop_params(params->rnode);
	pop_var(params, TRUE);
}

/* make_param --- make NAME into a function parameter */

static NODE *
make_param(char *name)
{
	NODE *r;

	getnode(r);
	r->type = Node_param_list;
	r->rnode = NULL;
	r->param = name;
	r->param_cnt = param_counter++;
	return (install(name, r));
}

static struct fdesc {
	char *name;
	short used;
	short defined;
	struct fdesc *next;
} *ftable[HASHSIZE];

/* func_use --- track uses and definitions of functions */

static void
func_use(const char *name, enum defref how)
{
	struct fdesc *fp;
	int len;
	int ind;

	len = strlen(name);
	ind = hash(name, len, HASHSIZE, NULL);

	for (fp = ftable[ind]; fp != NULL; fp = fp->next) {
		if (strcmp(fp->name, name) == 0) {
			if (how == FUNC_DEFINE)
				fp->defined++;
			else
				fp->used++;
			return;
		}
	}

	/* not in the table, fall through to allocate a new one */

	emalloc(fp, struct fdesc *, sizeof(struct fdesc), "func_use");
	memset(fp, '\0', sizeof(struct fdesc));
	emalloc(fp->name, char *, len + 1, "func_use");
	strcpy(fp->name, name);
	if (how == FUNC_DEFINE)
		fp->defined++;
	else
		fp->used++;
	fp->next = ftable[ind];
	ftable[ind] = fp;
}

/* check_funcs --- verify functions that are called but not defined */

static void
check_funcs()
{
	struct fdesc *fp, *next;
	int i;

	for (i = 0; i < HASHSIZE; i++) {
		for (fp = ftable[i]; fp != NULL; fp = fp->next) {
#ifdef REALLYMEAN
			/* making this the default breaks old code. sigh. */
			if (fp->defined == 0) {
				error(
		_("function `%s' called but never defined"), fp->name);
				errcount++;
			}
#else
			if (do_lint && fp->defined == 0)
				lintwarn(
		_("function `%s' called but never defined"), fp->name);
#endif
			if (do_lint && fp->used == 0) {
				lintwarn(_("function `%s' defined but never called"),
					fp->name);
			}
		}
	}

	/* now let's free all the memory */
	for (i = 0; i < HASHSIZE; i++) {
		for (fp = ftable[i]; fp != NULL; fp = next) {
			next = fp->next;
			free(fp->name);
			free(fp);
		}
	}
}

/* param_sanity --- look for parameters that are regexp constants */

static void
param_sanity(NODE *arglist)
{
	NODE *argp, *arg;
	int i;

	for (i = 1, argp = arglist; argp != NULL; argp = argp->rnode, i++) {
		arg = argp->lnode;
		if (arg->type == Node_regex)
			warning(_("regexp constant for parameter #%d yields boolean value"), i);
	}
}

/* deferred variables --- those that are only defined if needed. */

/*
 * Is there any reason to use a hash table for deferred variables?  At the
 * moment, there are only 1 to 3 such variables, so it may not be worth
 * the overhead.  If more modules start using this facility, it should
 * probably be converted into a hash table.
 */

static struct deferred_variable {
	NODE *(*load_func)(void);
	struct deferred_variable *next;
	char name[1];	/* variable-length array */
} *deferred_variables;

/* register_deferred_variable --- add a var name and loading function to the list */

void
register_deferred_variable(const char *name, NODE *(*load_func)(void))
{
	struct deferred_variable *dv;
	size_t sl = strlen(name);

	emalloc(dv, struct deferred_variable *, sizeof(*dv)+sl,
		"register_deferred_variable");
	dv->load_func = load_func;
	dv->next = deferred_variables;
	memcpy(dv->name, name, sl+1);
	deferred_variables = dv;
}

/* variable --- make sure NAME is in the symbol table */

NODE *
variable(char *name, int can_free, NODETYPE type)
{
	register NODE *r;

	if ((r = lookup(name)) != NULL) {
		if (r->type == Node_func)
			fatal(_("function `%s' called with space between name and `(',\nor used as a variable or an array"),
				r->vname);

	} else {
		/* not found */
		struct deferred_variable *dv;

		for (dv = deferred_variables; TRUE; dv = dv->next) {
			if (dv == NULL) {
				/*
				 * This is the only case in which we may not
				 * free the string.
				 */
				NODE *n;

				if (type == Node_var_array)
					n = node(NULL, type, NULL);
				else
					n = node(Nnull_string, type, NULL);

				return install(name, n);
			}
			if (STREQ(name, dv->name)) {
				r = (*dv->load_func)();
				break;
			}
		}
	}
	if (can_free)
		free(name);
	return r;
}

/* mk_rexp --- make a regular expression constant */

static NODE *
mk_rexp(NODE *exp)
{
	NODE *n;

	if (exp->type == Node_regex)
		return exp;

	getnode(n);
	n->type = Node_dynregex;
	n->re_exp = exp;
	n->re_text = NULL;
	n->re_reg = NULL;
	n->re_flags = 0;
	n->re_cnt = 1;
	return n;
}

/* isnoeffect --- when used as a statement, has no side effects */

/*
 * To be completely general, we should recursively walk the parse
 * tree, to make sure that all the subexpressions also have no effect.
 * Instead, we just weaken the actual warning that's printed, up above
 * in the grammar.
 */

static int
isnoeffect(NODETYPE type)
{
	switch (type) {
	case Node_times:
	case Node_quotient:
	case Node_mod:
	case Node_plus:
	case Node_minus:
	case Node_subscript:
	case Node_concat:
	case Node_exp:
	case Node_unary_minus:
	case Node_field_spec:
	case Node_and:
	case Node_or:
	case Node_equal:
	case Node_notequal:
	case Node_less:
	case Node_greater:
	case Node_leq:
	case Node_geq:
	case Node_match:
	case Node_nomatch:
	case Node_not:
	case Node_val:
	case Node_in_array:
	case Node_NF:
	case Node_NR:
	case Node_FNR:
	case Node_FS:
	case Node_RS:
	case Node_FIELDWIDTHS:
	case Node_IGNORECASE:
	case Node_OFS:
	case Node_ORS:
	case Node_OFMT:
	case Node_CONVFMT:
	case Node_BINMODE:
	case Node_LINT:
	case Node_SUBSEP:
	case Node_TEXTDOMAIN:
		return TRUE;
	default:
		break;	/* keeps gcc -Wall happy */
	}

	return FALSE;
}

/* isassignable --- can this node be assigned to? */

static int
isassignable(register NODE *n)
{
	switch (n->type) {
	case Node_var_new:
	case Node_var:
	case Node_FIELDWIDTHS:
	case Node_RS:
	case Node_FS:
	case Node_FNR:
	case Node_NR:
	case Node_NF:
	case Node_IGNORECASE:
	case Node_OFMT:
	case Node_CONVFMT:
	case Node_ORS:
	case Node_OFS:
	case Node_LINT:
	case Node_BINMODE:
	case Node_SUBSEP:
	case Node_TEXTDOMAIN:
	case Node_field_spec:
	case Node_subscript:
		return TRUE;
	case Node_param_list:
		return ((n->flags & FUNC) == 0);  /* ok if not func name */
	default:
		break;	/* keeps gcc -Wall happy */
	}
	return FALSE;
}

/* stopme --- for debugging */

NODE *
stopme(NODE *tree ATTRIBUTE_UNUSED)
{
	return (NODE *) 0;
}

/* dumpintlstr --- write out an initial .po file entry for the string */

static void
dumpintlstr(const char *str, size_t len)
{
	char *cp;

	/* See the GNU gettext distribution for details on the file format */

	if (source != NULL) {
		/* ala the gettext sources, remove leading `./'s */
		for (cp = source; cp[0] == '.' && cp[1] == '/'; cp += 2)
			continue;
		printf("#: %s:%d\n", cp, sourceline);
	}

	printf("msgid ");
	pp_string_fp(stdout, str, len, '"', TRUE);
	putchar('\n');
	printf("msgstr \"\"\n\n");
	fflush(stdout);
}

/* dumpintlstr2 --- write out an initial .po file entry for the string and its plural */

static void
dumpintlstr2(const char *str1, size_t len1, const char *str2, size_t len2)
{
	char *cp;

	/* See the GNU gettext distribution for details on the file format */

	if (source != NULL) {
		/* ala the gettext sources, remove leading `./'s */
		for (cp = source; cp[0] == '.' && cp[1] == '/'; cp += 2)
			continue;
		printf("#: %s:%d\n", cp, sourceline);
	}

	printf("msgid ");
	pp_string_fp(stdout, str1, len1, '"', TRUE);
	putchar('\n');
	printf("msgid_plural ");
	pp_string_fp(stdout, str2, len2, '"', TRUE);
	putchar('\n');
	printf("msgstr[0] \"\"\nmsgstr[1] \"\"\n\n");
	fflush(stdout);
}

/* count_args --- count the number of printf arguments */

static void
count_args(NODE *tree)
{
	size_t count = 0;
	NODE *save_tree;

	assert(tree->type == Node_K_printf
		|| (tree->type == Node_builtin && tree->builtin == do_sprintf));
	save_tree = tree;

	tree = tree->lnode;	/* printf format string */

	for (count = 0; tree != NULL; tree = tree->rnode)
		count++;

	save_tree->printf_count = count;
}

/* isarray --- can this type be subscripted? */

static int
isarray(NODE *n)
{
	switch (n->type) {
	case Node_var_new:
	case Node_var_array:
		return TRUE;
	case Node_param_list:
		return (n->flags & FUNC) == 0;
	case Node_array_ref:
		cant_happen();
		break;
	default:
		break;	/* keeps gcc -Wall happy */
	}

	return FALSE;
}

/* See if name is a special token. */

int
check_special(const char *name)
{
	int low, high, mid;
	int i;
#if 'a' == 0x81 /* it's EBCDIC */
	static int did_sort = FALSE;

	if (! did_sort) {
		qsort(tokentab, sizeof(tokentab) / sizeof(tokentab[0]),
				sizeof(tokentab[0]), tokcompare);
		did_sort = TRUE;
	}
#endif


	low = 0;
	high = (sizeof(tokentab) / sizeof(tokentab[0])) - 1;
	while (low <= high) {
		mid = (low + high) / 2;
		i = *name - tokentab[mid].operator[0];
		if (i == 0)
			i = strcmp(name, tokentab[mid].operator);

		if (i < 0)		/* token < mid */
			high = mid - 1;
		else if (i > 0)		/* token > mid */
			low = mid + 1;
		else
			return mid;
	}
	return -1;
}

/*
 * This provides a private version of functions that act like VMS's
 * variable-length record filesystem, where there was a bug on
 * certain source files.
 */

static FILE *fp = NULL;

/* read_one_line --- return one input line at a time. mainly for debugging. */

static ssize_t
read_one_line(int fd, void *buffer, size_t count)
{
	char buf[BUFSIZ];

	/* Minor potential memory leak here. Too bad. */
	if (fp == NULL) {
		fp = fdopen(fd, "r");
		if (fp == NULL) {
			fprintf(stderr, "ugh. fdopen: %s\n", strerror(errno));
			exit(EXIT_FAILURE);
		}
	}

	if (fgets(buf, sizeof buf, fp) == NULL)
		return 0;

	memcpy(buffer, buf, strlen(buf));
	return strlen(buf);
}

/* one_line_close --- close the open file being read with read_one_line() */

static int
one_line_close(int fd)
{
	int ret;

	if (fp == NULL || fd != fileno(fp))
		fatal("debugging read/close screwed up!");

	ret = fclose(fp);
	fp = NULL;
	return ret;
}

/* constant_fold --- try to fold constant operations */

static NODE *
constant_fold(NODE *left, NODETYPE op, NODE *right)
{
	AWKNUM result;
	extern double fmod P((double x, double y));

	if (! do_optimize)
		return node(left, op, right);

	/* Unary not */
	if (right == NULL) {
		if (op == Node_not && left->type == Node_val) {
			if ((left->flags & (STRCUR|STRING)) != 0) {
				NODE *ret;
				if (left->stlen == 0) {
					ret = make_number((AWKNUM) 1.0);
				} else {
					ret = make_number((AWKNUM) 0.0);
				}
				unref(left);

				return ret;
			} else {
				if (left->numbr == 0) {
					left->numbr = 1.0;
				} else {
					left->numbr = 0.0;
				}

				return left;
			}
		}

		return node(left, op, right);
	}

	/* String concatentation of two string cnstants */
	if (op == Node_concat
	    && left->type == Node_val
	    && (left->flags & (STRCUR|STRING)) != 0
	    && right->type == Node_val
	    && (right->flags & (STRCUR|STRING)) != 0) {
		size_t newlen = left->stlen + right->stlen + 2;

		erealloc(left->stptr, char *, newlen, "constant_fold");
		memcpy(left->stptr + left->stlen, right->stptr, right->stlen);
		left->stptr[left->stlen + right->stlen] = '\0';
		left->stlen += right->stlen;

		unref(right);
		return left;
	}

	/*
	 * From here down, numeric operations.
	 * Check for string and bail out if have them.
	 */
	if (left->type != Node_val
	    || (left->flags & (STRCUR|STRING)) != 0
	    || right->type != Node_val
	    || (left->flags & (STRCUR|STRING)) != 0) {
		return node(left, op, right);
	}

	/* Numeric operations: */
	switch (op) {
	case Node_not:
	case Node_exp:
	case Node_times:
	case Node_quotient:
	case Node_mod:
	case Node_plus:
	case Node_minus:
		break;
	default:
		return node(left, op, right);
	}

	left->numbr = force_number(left);
	right->numbr = force_number(right);

	result = left->numbr;
	switch (op) {
	case Node_exp:
		result = calc_exp(left->numbr, right->numbr);
		break;
	case Node_times:
		result *= right->numbr;
		break;
	case Node_quotient:
		result /= right->numbr;
		break;
	case Node_mod:
		if (right->numbr == 0)
			fatal(_("division by zero attempted in `%%'"));
#ifdef HAVE_FMOD
		result = fmod(result, right->numbr);
#else	/* ! HAVE_FMOD */
		(void) modf(left->numbr / right->numbr, &result);
		result = left->numbr - result * right->numbr;
#endif	/* ! HAVE_FMOD */
		break;
	case Node_plus:
		result += right->numbr;
		break;
	case Node_minus:
		result -= right->numbr;
		break;
	default:
		/* Shut up compiler warnings */
		fatal("can't happen");
		break;
	}

	unref(right);
	left->numbr = result;

	return left;
}

/* optimize_concat --- optimize the general "x = x y z a" case */

static NODE *
optimize_concat(NODE *left, NODETYPE op, NODE *right)
{
	NODE *top, *leftmost;

	if (op != Node_assign)
		return node(left, op, right);

	/*
	 * optimization of `x = x y'.  can save lots of time
	 * if done a lot.
	 */
	if ((    left->type == Node_var
		|| left->type == Node_var_new
		|| left->type == Node_param_list)
	      && right->type == Node_concat) {
		/* find bottom of tree, save it */
		for (top = right; top->lnode != NULL && top->type == Node_concat; top = top->lnode) {
			leftmost = top->lnode;
			if (leftmost->type == Node_concat)
				continue;

			/* at this point, we've run out of concatentation */
			if (leftmost != left)
				return node(left, op, right);

			top->lnode = Nnull_string;
			return node(left, Node_assign_concat, right);
		}
	}
	return node(left, op, right);
}
#line 3992 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 184 "awkgram.y"
{
			check_funcs();
		}
break;
case 3:
#line 192 "awkgram.y"
{
		begin_or_end_rule = parsing_end_rule = FALSE;
		yyerrok;
	  }
break;
case 4:
#line 197 "awkgram.y"
{
		begin_or_end_rule = parsing_end_rule = FALSE;
		/*
		 * If errors, give up, don't produce an infinite
		 * stream of syntax error messages.
		 */
  		/* yyerrok; */
  	  }
break;
case 5:
#line 209 "awkgram.y"
{
		yyvsp[-1].nodeval->rnode = yyvsp[0].nodeval;
	  }
break;
case 6:
#line 213 "awkgram.y"
{
		if (yyvsp[-1].nodeval->lnode != NULL) {
			/* pattern rule with non-empty pattern */
			yyvsp[-1].nodeval->rnode = node(NULL, Node_K_print_rec, NULL);
		} else {
			/* an error */
			if (begin_or_end_rule)
				msg(_("%s blocks must have an action part"),
					(parsing_end_rule ? "END" : "BEGIN"));
			else
				msg(_("each rule must have a pattern or an action part"));
			errcount++;
		}
	  }
break;
case 7:
#line 228 "awkgram.y"
{
		can_return = FALSE;
		if (yyvsp[-1].nodeval)
			func_install(yyvsp[-1].nodeval, yyvsp[0].nodeval);
		yyerrok;
	  }
break;
case 8:
#line 238 "awkgram.y"
{
		yyval.nodeval = append_pattern(&expression_value, (NODE *) NULL);
	  }
break;
case 9:
#line 242 "awkgram.y"
{
		yyval.nodeval = append_pattern(&expression_value, yyvsp[0].nodeval);
	  }
break;
case 10:
#line 246 "awkgram.y"
{
		NODE *r;

		getnode(r);
		r->type = Node_line_range;
		r->condpair = node(yyvsp[-2].nodeval, Node_cond_pair, yyvsp[0].nodeval);
		r->triggered = FALSE;
		yyval.nodeval = append_pattern(&expression_value, r);
	  }
break;
case 11:
#line 256 "awkgram.y"
{
		static int begin_seen = 0;
		if (do_lint_old && ++begin_seen == 2)
			warning(_("old awk does not support multiple `BEGIN' or `END' rules"));

		begin_or_end_rule = TRUE;
		yyval.nodeval = append_pattern(&begin_block, (NODE *) NULL);
	  }
break;
case 12:
#line 265 "awkgram.y"
{
		static int end_seen = 0;
		if (do_lint_old && ++end_seen == 2)
			warning(_("old awk does not support multiple `BEGIN' or `END' rules"));

		begin_or_end_rule = parsing_end_rule = TRUE;
		yyval.nodeval = append_pattern(&end_block, (NODE *) NULL);
	  }
break;
case 13:
#line 277 "awkgram.y"
{ yyval.nodeval = yyvsp[-3].nodeval; }
break;
case 14:
#line 282 "awkgram.y"
{ yyval.sval = yyvsp[0].sval; }
break;
case 15:
#line 284 "awkgram.y"
{ yyval.sval = yyvsp[0].sval; }
break;
case 16:
#line 286 "awkgram.y"
{
		yyerror(_("`%s' is a built-in function, it cannot be redefined"),
			tokstart);
		errcount++;
		yyval.sval = builtin_func;
		/* yyerrok; */
	  }
break;
case 19:
#line 302 "awkgram.y"
{
			param_counter = 0;
		}
break;
case 20:
#line 306 "awkgram.y"
{
			NODE *t;

			t = make_param(yyvsp[-4].sval);
			t->flags |= FUNC;
			yyval.nodeval = append_right(t, yyvsp[-2].nodeval);
			can_return = TRUE;
			/* check for duplicate parameter names */
			if (dup_parms(yyval.nodeval))
				errcount++;
		}
break;
case 21:
#line 325 "awkgram.y"
{ ++want_regexp; }
break;
case 22:
#line 327 "awkgram.y"
{
		  NODE *n;
		  size_t len = strlen(yyvsp[0].sval);

		  if (do_lint) {
			if (len == 0)
				lintwarn(_("regexp constant `//' looks like a C++ comment, but is not"));
			else if ((yyvsp[0].sval)[0] == '*' && (yyvsp[0].sval)[len-1] == '*')
				/* possible C comment */
				lintwarn(_("regexp constant `/%s/' looks like a C comment, but is not"), tokstart);
		  }
		  getnode(n);
		  n->type = Node_regex;
		  n->re_exp = make_string(yyvsp[0].sval, len);
		  n->re_reg = make_regexp(yyvsp[0].sval, len, FALSE, TRUE);
		  n->re_text = NULL;
		  n->re_flags = CONSTANT;
		  n->re_cnt = 1;
		  yyval.nodeval = n;
		}
break;
case 25:
#line 356 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 26:
#line 358 "awkgram.y"
{
		if (yyvsp[0].nodeval == NULL)
			yyval.nodeval = yyvsp[-1].nodeval;
		else {
			if (do_lint && isnoeffect(yyvsp[0].nodeval->type))
				lintwarn(_("statement may have no effect"));
			if (yyvsp[-1].nodeval == NULL)
				yyval.nodeval = yyvsp[0].nodeval;
			else
	    			yyval.nodeval = append_right(
					(yyvsp[-1].nodeval->type == Node_statement_list ? yyvsp[-1].nodeval
					  : node(yyvsp[-1].nodeval, Node_statement_list, (NODE *) NULL)),
					(yyvsp[0].nodeval->type == Node_statement_list ? yyvsp[0].nodeval
					  : node(yyvsp[0].nodeval, Node_statement_list, (NODE *) NULL)));
		}
	    	yyerrok;
	  }
break;
case 27:
#line 376 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 30:
#line 386 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 31:
#line 388 "awkgram.y"
{ yyval.nodeval = yyvsp[-1].nodeval; }
break;
case 32:
#line 390 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 33:
#line 392 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-6].nodeval, Node_K_switch, yyvsp[-2].nodeval); }
break;
case 34:
#line 394 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-3].nodeval, Node_K_while, yyvsp[0].nodeval); }
break;
case 35:
#line 396 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_K_do, yyvsp[-5].nodeval); }
break;
case 36:
#line 398 "awkgram.y"
{
		/*
		 * Efficiency hack.  Recognize the special case of
		 *
		 * 	for (iggy in foo)
		 * 		delete foo[iggy]
		 *
		 * and treat it as if it were
		 *
		 * 	delete foo
		 *
		 * Check that the body is a `delete a[i]' statement,
		 * and that both the loop var and array names match.
		 */
		if (yyvsp[0].nodeval != NULL && yyvsp[0].nodeval->type == Node_K_delete && yyvsp[0].nodeval->rnode != NULL) {
			NODE *arr, *sub;

			assert(yyvsp[0].nodeval->rnode->type == Node_expression_list);
			arr = yyvsp[0].nodeval->lnode;	/* array var */
			sub = yyvsp[0].nodeval->rnode->lnode;	/* index var */

			if (   (arr->type == Node_var_new
				|| arr->type == Node_var_array
				|| arr->type == Node_param_list)
			    && (sub->type == Node_var_new
				|| sub->type == Node_var
				|| sub->type == Node_param_list)
			    && strcmp(yyvsp[-5].sval, sub->vname) == 0
			    && strcmp(yyvsp[-3].sval, arr->vname) == 0) {
				yyvsp[0].nodeval->type = Node_K_delete_loop;
				yyval.nodeval = yyvsp[0].nodeval;
				free(yyvsp[-5].sval);	/* thanks to valgrind for pointing these out */
				free(yyvsp[-3].sval);
			}
			else
				goto regular_loop;
		} else {
	regular_loop:
			yyval.nodeval = node(yyvsp[0].nodeval, Node_K_arrayfor,
				make_for_loop(variable(yyvsp[-5].sval, CAN_FREE, Node_var),
				(NODE *) NULL, variable(yyvsp[-3].sval, CAN_FREE, Node_var_array)));
		}
	  }
break;
case 37:
#line 442 "awkgram.y"
{
		yyval.nodeval = node(yyvsp[0].nodeval, Node_K_for, (NODE *) make_for_loop(yyvsp[-9].nodeval, yyvsp[-6].nodeval, yyvsp[-3].nodeval));
	  }
break;
case 38:
#line 446 "awkgram.y"
{
		yyval.nodeval = node(yyvsp[0].nodeval, Node_K_for,
			(NODE *) make_for_loop(yyvsp[-8].nodeval, (NODE *) NULL, yyvsp[-3].nodeval));
	  }
break;
case 39:
#line 452 "awkgram.y"
{ yyval.nodeval = node((NODE *) NULL, Node_K_break, (NODE *) NULL); }
break;
case 40:
#line 455 "awkgram.y"
{ yyval.nodeval = node((NODE *) NULL, Node_K_continue, (NODE *) NULL); }
break;
case 41:
#line 457 "awkgram.y"
{ NODETYPE type;

		  if (begin_or_end_rule)
			yyerror(_("`%s' used in %s action"), "next",
				(parsing_end_rule ? "END" : "BEGIN"));
		  type = Node_K_next;
		  yyval.nodeval = node((NODE *) NULL, type, (NODE *) NULL);
		}
break;
case 42:
#line 466 "awkgram.y"
{
		  static short warned = FALSE;

		  if (do_traditional) {
			/*
			 * can't use yyerror, since may have overshot
			 * the source line
			 */
			errcount++;
			error(_("`nextfile' is a gawk extension"));
		  }
		  if (do_lint && ! warned) {
		  	warned = TRUE;
			lintwarn(_("`nextfile' is a gawk extension"));
		  }
		  if (begin_or_end_rule) {
			/* same thing */
			errcount++;
			error(_("`%s' used in %s action"), "nextfile",
				(parsing_end_rule ? "END" : "BEGIN"));
		  }
		  yyval.nodeval = node((NODE *) NULL, Node_K_nextfile, (NODE *) NULL);
		}
break;
case 43:
#line 490 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-1].nodeval, Node_K_exit, (NODE *) NULL); }
break;
case 44:
#line 492 "awkgram.y"
{
		  if (! can_return)
			yyerror(_("`return' used outside function context"));
		}
break;
case 45:
#line 497 "awkgram.y"
{
		  yyval.nodeval = node(yyvsp[-1].nodeval == NULL ? Nnull_string : yyvsp[-1].nodeval,
			Node_K_return, (NODE *) NULL);
		}
break;
case 47:
#line 513 "awkgram.y"
{ in_print = TRUE; in_parens = 0; }
break;
case 48:
#line 514 "awkgram.y"
{
		/*
		 * Optimization: plain `print' has no expression list, so $3 is null.
		 * If $3 is an expression list with one element (rnode == null)
		 * and lnode is a field spec for field 0, we have `print $0'.
		 * For both, use Node_K_print_rec, which is faster for these two cases.
		 */
		if (yyvsp[-3].nodetypeval == Node_K_print &&
		    (yyvsp[-1].nodeval == NULL
		     || (yyvsp[-1].nodeval->type == Node_expression_list
			&& yyvsp[-1].nodeval->rnode == NULL
			&& yyvsp[-1].nodeval->lnode->type == Node_field_spec
			&& yyvsp[-1].nodeval->lnode->lnode->type == Node_val
			&& yyvsp[-1].nodeval->lnode->lnode->numbr == 0.0))
		) {
			static short warned = FALSE;

			yyval.nodeval = node(NULL, Node_K_print_rec, yyvsp[0].nodeval);

			if (do_lint && yyvsp[-1].nodeval == NULL && begin_or_end_rule && ! warned) {
				warned = TRUE;
				lintwarn(
	_("plain `print' in BEGIN or END rule should probably be `print \"\"'"));
			}
		} else {
			yyval.nodeval = node(yyvsp[-1].nodeval, yyvsp[-3].nodetypeval, yyvsp[0].nodeval);
			if (yyval.nodeval->type == Node_K_printf)
				count_args(yyval.nodeval);
		}
	  }
break;
case 49:
#line 545 "awkgram.y"
{ yyval.nodeval = node(variable(yyvsp[-3].sval, CAN_FREE, Node_var_array), Node_K_delete, yyvsp[-1].nodeval); }
break;
case 50:
#line 547 "awkgram.y"
{
		  static short warned = FALSE;

		  if (do_lint && ! warned) {
			warned = TRUE;
			lintwarn(_("`delete array' is a gawk extension"));
		  }
		  if (do_traditional) {
			/*
			 * can't use yyerror, since may have overshot
			 * the source line
			 */
			errcount++;
			error(_("`delete array' is a gawk extension"));
		  }
		  yyval.nodeval = node(variable(yyvsp[0].sval, CAN_FREE, Node_var_array), Node_K_delete, (NODE *) NULL);
		}
break;
case 51:
#line 565 "awkgram.y"
{
		  /*
		   * this is for tawk compatibility. maybe the warnings
		   * should always be done.
		   */
		  static short warned = FALSE;

		  if (do_lint && ! warned) {
			warned = TRUE;
			lintwarn(_("`delete(array)' is a non-portable tawk extension"));
		  }
		  if (do_traditional) {
			/*
			 * can't use yyerror, since may have overshot
			 * the source line
			 */
			errcount++;
			error(_("`delete(array)' is a non-portable tawk extension"));
		  }
		  yyval.nodeval = node(variable(yyvsp[-1].sval, CAN_FREE, Node_var_array), Node_K_delete, (NODE *) NULL);
		}
break;
case 52:
#line 587 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 53:
#line 592 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 54:
#line 594 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 55:
#line 599 "awkgram.y"
{
		if (yyvsp[0].nodeval == NULL) {
			yyval.nodeval = NULL;
		} else {
			NODE *dflt = NULL;
			NODE *head = yyvsp[0].nodeval;
			NODE *curr;
	
			const char **case_values = NULL;
	
			int maxcount = 128;
			int case_count = 0;
			int i;
	
			emalloc(case_values, const char **, sizeof(char*) * maxcount, "switch_body");
			for (curr = yyvsp[0].nodeval; curr != NULL; curr = curr->rnode) {
				/* Assure that case statement values are unique. */
				if (curr->lnode->type == Node_K_case) {
					char *caseval;
	
					if (curr->lnode->lnode->type == Node_regex)
						caseval = curr->lnode->lnode->re_exp->stptr;
					else
						caseval = force_string(tree_eval(curr->lnode->lnode))->stptr;
	
					for (i = 0; i < case_count; i++)
						if (strcmp(caseval, case_values[i]) == 0)
							yyerror(_("duplicate case values in switch body: %s"), caseval);
	
					if (case_count >= maxcount) {
						maxcount += 128;
						erealloc(case_values, const char **, sizeof(char*) * maxcount, "switch_body");
					}
					case_values[case_count++] = caseval;
				} else {
					/* Otherwise save a pointer to the default node.  */
					if (dflt != NULL)
						yyerror(_("Duplicate `default' detected in switch body"));
					dflt = curr;
				}
			}
	
			free(case_values);
	
			/* Create the switch body. */
			yyval.nodeval = node(head, Node_switch_body, dflt);
		}
	}
break;
case 56:
#line 651 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 57:
#line 653 "awkgram.y"
{
		if (yyvsp[0].nodeval == NULL)
			yyval.nodeval = yyvsp[-1].nodeval;
		else {
			if (do_lint && isnoeffect(yyvsp[0].nodeval->type))
				lintwarn(_("statement may have no effect"));
			if (yyvsp[-1].nodeval == NULL)
				yyval.nodeval = node(yyvsp[0].nodeval, Node_case_list, (NODE *) NULL);
			else
				yyval.nodeval = append_right(
					(yyvsp[-1].nodeval->type == Node_case_list ? yyvsp[-1].nodeval : node(yyvsp[-1].nodeval, Node_case_list, (NODE *) NULL)),
					(yyvsp[0].nodeval->type == Node_case_list ? yyvsp[0].nodeval : node(yyvsp[0].nodeval, Node_case_list, (NODE *) NULL))
				);
		}
	    	yyerrok;
	  }
break;
case 58:
#line 670 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 59:
#line 675 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-3].nodeval, Node_K_case, yyvsp[0].nodeval); }
break;
case 60:
#line 677 "awkgram.y"
{ yyval.nodeval = node((NODE *) NULL, Node_K_default, yyvsp[0].nodeval); }
break;
case 61:
#line 682 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 62:
#line 684 "awkgram.y"
{
		yyvsp[0].nodeval->numbr = -(force_number(yyvsp[0].nodeval));
		yyval.nodeval = yyvsp[0].nodeval;
	  }
break;
case 63:
#line 689 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 64:
#line 691 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 65:
#line 693 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 69:
#line 708 "awkgram.y"
{ yyval.nodeval = yyvsp[-1].nodeval; }
break;
case 70:
#line 713 "awkgram.y"
{
		in_print = FALSE;
		in_parens = 0;
		yyval.nodeval = NULL;
	  }
break;
case 71:
#line 718 "awkgram.y"
{ in_print = FALSE; in_parens = 0; }
break;
case 72:
#line 719 "awkgram.y"
{
		yyval.nodeval = node(yyvsp[0].nodeval, yyvsp[-2].nodetypeval, (NODE *) NULL);
		if (yyvsp[-2].nodetypeval == Node_redirect_twoway
		    && yyvsp[0].nodeval->type == Node_K_getline
		    && yyvsp[0].nodeval->rnode != NULL
		    && yyvsp[0].nodeval->rnode->type == Node_redirect_twoway)
			yyerror(_("multistage two-way pipelines don't work"));
	  }
break;
case 73:
#line 731 "awkgram.y"
{
		yyval.nodeval = node(yyvsp[-3].nodeval, Node_K_if, 
			node(yyvsp[0].nodeval, Node_if_branches, (NODE *) NULL));
	  }
break;
case 74:
#line 737 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-6].nodeval, Node_K_if,
				node(yyvsp[-3].nodeval, Node_if_branches, yyvsp[0].nodeval)); }
break;
case 79:
#line 753 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 80:
#line 755 "awkgram.y"
{ yyval.nodeval = node(yyvsp[0].nodeval, Node_redirect_input, (NODE *) NULL); }
break;
case 81:
#line 760 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 82:
#line 762 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 83:
#line 767 "awkgram.y"
{ yyval.nodeval = make_param(yyvsp[0].sval); }
break;
case 84:
#line 769 "awkgram.y"
{ yyval.nodeval = append_right(yyvsp[-2].nodeval, make_param(yyvsp[0].sval)); yyerrok; }
break;
case 85:
#line 771 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 86:
#line 773 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 87:
#line 775 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 88:
#line 781 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 89:
#line 783 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 90:
#line 788 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 91:
#line 790 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 92:
#line 795 "awkgram.y"
{ yyval.nodeval = node(yyvsp[0].nodeval, Node_expression_list, (NODE *) NULL); }
break;
case 93:
#line 797 "awkgram.y"
{
			yyval.nodeval = append_right(yyvsp[-2].nodeval,
				node(yyvsp[0].nodeval, Node_expression_list, (NODE *) NULL));
			yyerrok;
		}
break;
case 94:
#line 803 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 95:
#line 805 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 96:
#line 807 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 97:
#line 809 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 98:
#line 814 "awkgram.y"
{
		  if (do_lint && yyvsp[0].nodeval->type == Node_regex)
			lintwarn(_("regular expression on right of assignment"));
		  yyval.nodeval = optimize_concat(yyvsp[-2].nodeval, yyvsp[-1].nodetypeval, yyvsp[0].nodeval);
		}
break;
case 99:
#line 820 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_and, yyvsp[0].nodeval); }
break;
case 100:
#line 822 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_or, yyvsp[0].nodeval); }
break;
case 101:
#line 824 "awkgram.y"
{
		  if (yyvsp[-2].nodeval->type == Node_regex)
			warning(_("regular expression on left of `~' or `!~' operator"));
		  yyval.nodeval = node(yyvsp[-2].nodeval, yyvsp[-1].nodetypeval, mk_rexp(yyvsp[0].nodeval));
		}
break;
case 102:
#line 830 "awkgram.y"
{
		  if (do_lint_old)
		    warning(_("old awk does not support the keyword `in' except after `for'"));
		  yyval.nodeval = node(variable(yyvsp[0].sval, CAN_FREE, Node_var_array), Node_in_array, yyvsp[-2].nodeval);
		}
break;
case 103:
#line 836 "awkgram.y"
{
		  if (do_lint && yyvsp[0].nodeval->type == Node_regex)
			lintwarn(_("regular expression on right of comparison"));
		  yyval.nodeval = node(yyvsp[-2].nodeval, yyvsp[-1].nodetypeval, yyvsp[0].nodeval);
		}
break;
case 104:
#line 842 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-4].nodeval, Node_cond_exp, node(yyvsp[-2].nodeval, Node_if_branches, yyvsp[0].nodeval));}
break;
case 105:
#line 844 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 106:
#line 849 "awkgram.y"
{ yyval.nodetypeval = yyvsp[0].nodetypeval; }
break;
case 107:
#line 851 "awkgram.y"
{ yyval.nodetypeval = yyvsp[0].nodetypeval; }
break;
case 108:
#line 853 "awkgram.y"
{ yyval.nodetypeval = Node_assign_quotient; }
break;
case 109:
#line 858 "awkgram.y"
{ yyval.nodetypeval = yyvsp[0].nodetypeval; }
break;
case 110:
#line 860 "awkgram.y"
{ yyval.nodetypeval = Node_less; }
break;
case 112:
#line 865 "awkgram.y"
{ yyval.nodetypeval = Node_greater; }
break;
case 113:
#line 870 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 114:
#line 872 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 115:
#line 874 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-1].nodeval, Node_concat, yyvsp[0].nodeval); }
break;
case 117:
#line 881 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_exp, yyvsp[0].nodeval); }
break;
case 118:
#line 883 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_times, yyvsp[0].nodeval); }
break;
case 119:
#line 885 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_quotient, yyvsp[0].nodeval); }
break;
case 120:
#line 887 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_mod, yyvsp[0].nodeval); }
break;
case 121:
#line 889 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_plus, yyvsp[0].nodeval); }
break;
case 122:
#line 891 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[-2].nodeval, Node_minus, yyvsp[0].nodeval); }
break;
case 123:
#line 893 "awkgram.y"
{
		  if (do_lint && parsing_end_rule && yyvsp[0].nodeval == NULL)
			lintwarn(_("non-redirected `getline' undefined inside END action"));
		  yyval.nodeval = node(yyvsp[-1].nodeval, Node_K_getline, yyvsp[0].nodeval);
		}
break;
case 124:
#line 899 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-1].nodeval, Node_postincrement, (NODE *) NULL); }
break;
case 125:
#line 901 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-1].nodeval, Node_postdecrement, (NODE *) NULL); }
break;
case 126:
#line 903 "awkgram.y"
{
		  if (do_lint_old) {
		    warning(_("old awk does not support the keyword `in' except after `for'"));
		    warning(_("old awk does not support multidimensional arrays"));
		  }
		  yyval.nodeval = node(variable(yyvsp[0].sval, CAN_FREE, Node_var_array), Node_in_array, yyvsp[-3].nodeval);
		}
break;
case 127:
#line 916 "awkgram.y"
{
		  yyval.nodeval = node(yyvsp[0].nodeval, Node_K_getline,
			 node(yyvsp[-3].nodeval, yyvsp[-2].nodetypeval, (NODE *) NULL));
		}
break;
case 128:
#line 921 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_exp, yyvsp[0].nodeval); }
break;
case 129:
#line 923 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_times, yyvsp[0].nodeval); }
break;
case 130:
#line 925 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_quotient, yyvsp[0].nodeval); }
break;
case 131:
#line 927 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_mod, yyvsp[0].nodeval); }
break;
case 132:
#line 929 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_plus, yyvsp[0].nodeval); }
break;
case 133:
#line 931 "awkgram.y"
{ yyval.nodeval = node(yyvsp[-2].nodeval, Node_minus, yyvsp[0].nodeval); }
break;
case 134:
#line 936 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 135:
#line 938 "awkgram.y"
{ yyval.nodeval = constant_fold(yyvsp[0].nodeval, Node_not, (NODE *) NULL); }
break;
case 136:
#line 940 "awkgram.y"
{ yyval.nodeval = yyvsp[-1].nodeval; }
break;
case 137:
#line 943 "awkgram.y"
{ yyval.nodeval = snode(yyvsp[-1].nodeval, Node_builtin, (int) yyvsp[-3].lval); }
break;
case 138:
#line 945 "awkgram.y"
{ yyval.nodeval = snode(yyvsp[-1].nodeval, Node_builtin, (int) yyvsp[-3].lval); }
break;
case 139:
#line 947 "awkgram.y"
{
		static short warned1 = FALSE, warned2 = FALSE;

		if (do_lint && ! warned1) {
			warned1 = TRUE;
			lintwarn(_("call of `length' without parentheses is not portable"));
		}
		yyval.nodeval = snode((NODE *) NULL, Node_builtin, (int) yyvsp[0].lval);
		if (do_posix && ! warned2) {
			warned2 = TRUE;
			warning(_("call of `length' without parentheses is deprecated by POSIX"));
		}
	  }
break;
case 140:
#line 961 "awkgram.y"
{
		yyval.nodeval = node(yyvsp[-1].nodeval, Node_func_call, make_string(yyvsp[-3].sval, strlen(yyvsp[-3].sval)));
		yyval.nodeval->funcbody = NULL;
		func_use(yyvsp[-3].sval, FUNC_USE);
		param_sanity(yyvsp[-1].nodeval);
		free(yyvsp[-3].sval);
	  }
break;
case 142:
#line 970 "awkgram.y"
{ yyval.nodeval = node(yyvsp[0].nodeval, Node_preincrement, (NODE *) NULL); }
break;
case 143:
#line 972 "awkgram.y"
{ yyval.nodeval = node(yyvsp[0].nodeval, Node_predecrement, (NODE *) NULL); }
break;
case 144:
#line 974 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 145:
#line 976 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 146:
#line 979 "awkgram.y"
{
		  if (yyvsp[0].nodeval->type == Node_val && (yyvsp[0].nodeval->flags & (STRCUR|STRING)) == 0) {
			yyvsp[0].nodeval->numbr = -(force_number(yyvsp[0].nodeval));
			yyval.nodeval = yyvsp[0].nodeval;
		  } else
			yyval.nodeval = node(yyvsp[0].nodeval, Node_unary_minus, (NODE *) NULL);
		}
break;
case 147:
#line 987 "awkgram.y"
{
		  /*
		   * was: $$ = $2
		   * POSIX semantics: force a conversion to numeric type
		   */
		  yyval.nodeval = node (make_number(0.0), Node_plus, yyvsp[0].nodeval);
		}
break;
case 148:
#line 998 "awkgram.y"
{ yyval.nodeval = NULL; }
break;
case 149:
#line 1000 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 150:
#line 1005 "awkgram.y"
{ yyval.nodeval = variable(yyvsp[0].sval, CAN_FREE, Node_var_new); }
break;
case 151:
#line 1007 "awkgram.y"
{
		NODE *n;

		if ((n = lookup(yyvsp[-3].sval)) != NULL && ! isarray(n)) {
			yyerror(_("use of non-array as array"));
			yyval.nodeval = node(variable(yyvsp[-3].sval, CAN_FREE, Node_var_array), Node_subscript, yyvsp[-1].nodeval);
		} else if (yyvsp[-1].nodeval == NULL) {
			fatal(_("invalid subscript expression"));
		} else if (yyvsp[-1].nodeval->rnode == NULL) {
			yyval.nodeval = node(variable(yyvsp[-3].sval, CAN_FREE, Node_var_array), Node_subscript, yyvsp[-1].nodeval->lnode);
			freenode(yyvsp[-1].nodeval);
		} else
			yyval.nodeval = node(variable(yyvsp[-3].sval, CAN_FREE, Node_var_array), Node_subscript, yyvsp[-1].nodeval);
	  }
break;
case 152:
#line 1021 "awkgram.y"
{ yyval.nodeval = yyvsp[0].nodeval; }
break;
case 153:
#line 1032 "awkgram.y"
{
		NODE *n = node(yyvsp[-1].nodeval, Node_field_spec, (NODE *) NULL);
		if (yyvsp[0].sval != NULL) {
			if (yyvsp[0].sval[0] == '+')
				yyval.nodeval = node(n, Node_postincrement, (NODE *) NULL);
			else
				yyval.nodeval = node(n, Node_postdecrement, (NODE *) NULL);
		} else {
			yyval.nodeval = n;
		}
	  }
break;
case 154:
#line 1046 "awkgram.y"
{ yyval.sval = "+"; }
break;
case 155:
#line 1047 "awkgram.y"
{ yyval.sval = "-"; }
break;
case 156:
#line 1048 "awkgram.y"
{ yyval.sval = NULL; }
break;
case 158:
#line 1056 "awkgram.y"
{ yyerrok; }
break;
case 159:
#line 1060 "awkgram.y"
{ yyerrok; }
break;
case 162:
#line 1069 "awkgram.y"
{ yyerrok; }
break;
case 163:
#line 1073 "awkgram.y"
{ yyerrok; }
break;
case 164:
#line 1076 "awkgram.y"
{ yyerrok; }
break;
#line 5169 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
